

#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft3def.h"
#include "sigdef.h"
#include "seldef.h"
#include "screendef.h"



// Power to the fourth may become a very large number.
// Define something small to multiply by to prevent overflows.
#define P4SCALE 0.000000000000000000001

void place_carr_indicator(int pnt)
{
if(bg_carrier_x >=0)
  {
  lir_putbox(bg_carrier_x,bg.ytop+1,3,text_height,bg_behind_carrcur);
  }
bg_carrier_x=bg.pixels_per_point*(pnt-bg_first_xpoint)+bg_first_xpixel;  
if(bg_carrier_x < bg_first_xpixel)bg_carrier_x=bg_first_xpixel;
if(bg_carrier_x > bg_last_xpixel-3)bg_carrier_x=bg_last_xpixel-3;
lir_getbox(bg_carrier_x,bg.ytop+1,3,text_height,bg_behind_carrcur);
lir_fillbox(bg_carrier_x,bg.ytop+1,3,text_height,10);
}

void remove_carr_indicator(void)
{
if(bg_carrier_x >=0)
  {
  lir_putbox(bg_carrier_x,bg.ytop+1,3,text_height,bg_behind_carrcur);
  }
}

void fft3_mix2(void)
{
int i, j, k, n, ia, ib, ic, ix, iy, pb, sizhalf;
int last_point;
float ampfac,cg_mid;
float big;
int nstep;
int nn, mm;
int siz, carr_center;
#define NOISE_FILTERS 2
#define NOISE_POINTS 5

float noise[2*NOISE_FILTERS];
float *z, *za, *zb, *zc, *zca, *zp, *carr, *zr, *zo, *zw;
float t1,t2,t3,t4,t5;
float r1,r2,c1,c2,c3;
float noise_floor, a2, b2, re, im;
float noi2, sina, a2s, b2s;
float sellim_correction, fac;
noise_floor=0;
sizhalf=mix2_size/2;
siz=mix2_size;
carr_center=fft3_size/2;
if(sw_onechan)
  {
// The desired signal should be at frequency=0 (point=fft3_size/2)
// In case AFC is enabled or a coherent processing is selected
// We take the responsibility to center the desired passband on the
// peak of the averaged fft3 spectrum.
  zp=&fft3_slowsum[-bg_first_xpoint];
  if( afc2_active_flag != 0)
    {
// Look for a maximum within half the flat passband.  
    mm=(1+bg_flatpoints+bg_curvpoints)/2;
    mm=(bg.afc2_range*mm)/100;
    if(mm == 0)mm=1;
    ia=fft3_size/2-mm;
    ib=fft3_size/2+mm;
    if(ia < 0)ia=0;
    if(ib >= bg_xpoints)ib=bg_xpoints-1;
    t1=0;
    for(i=ia; i<=ib; i++)
      {
      if(t1 < zp[i])
        {
        t1 = zp[i];
        carr_center=i;
        }
      }
// The spectrum may be very asymmetric.      
// Calculate the moment of inertia of the spectrum around the selected
// point and it's neighbours.
// Step either way to minimize it.
    t1=0;
    t2=0;
    t3=0;
    nstep=0;
    mm=(1+bg_flatpoints+bg_curvpoints)/(2*bg.coh_factor);
    for(i=1; i<=mm; i++)
      {
      k=i*i;
      t1+=k*(zp[carr_center-1+i]+zp[carr_center-1-i]);
      t2+=k*(zp[carr_center  +i]+zp[carr_center  -i]);
      t3+=k*(zp[carr_center+1+i]+zp[carr_center+1-i]);
      }
step_carrcenter_one:;    
    if(t1 < t2 && t1 < t3)
      {
      carr_center--;
      t3=t2;
      t2=t1;
      t1=0;
      for(i=1; i<=mm; i++)
        {
        k=i*i;
        t1+=k*(zp[carr_center-1+i]+zp[carr_center-1-i]);
        }
      nstep++;            
      if(nstep < mm/4)goto step_carrcenter_one;  
      }
    if(t3 < t2 && t3 < t1)
      {
      carr_center++;
      t1=t2;
      t2=t3;
      t3=0;
      for(i=1; i<=mm; i++)
        {
        k=i*i;
        t3+=k*(zp[carr_center+1+i]+zp[carr_center+1-i]);
        }
      nstep++;            
      if(nstep < mm/4)goto step_carrcenter_one;  
      }
    place_carr_indicator(carr_center);
    }  
  if( afc2_active_flag != 0 || genparm[CW_DECODE_ENABLE] != 0)
    {
// Compute the power within several narrow filters near the passband.
// Get the average while excluding large values.
// This way occasional signals outside our filter will not
// be included in the noise floor.
    mm=bg_flatpoints+2*bg_curvpoints+NOISE_SEP;
    t3=BIG;
    for(k=0; k<NOISE_FILTERS; k++)
      {
      t1=0;
      t2=0;
      for(i=0; i<NOISE_POINTS; i++)
        {
        j=mm+i+k*(NOISE_POINTS+NOISE_SEP);
        t1+=zp[carr_center+j];
        t2+=zp[carr_center-j];
        }
      noise[2*k]=t1;
      noise[2*k+1]=t2;
      if(t1<t3)t3=t1;
      if(t2<t3)t3=t2;
      }
    k=0;
    t1=0;
    t3*=1.5;
    for(i=0; i<2*NOISE_FILTERS; i++)
      {
      if(noise[i] < t3)
        {
        t1+=noise[i];
        k++;
        }
      }
    noise_floor=t1/(k*NOISE_POINTS);
    }
// Select mix2_size points centered at fft3_size/2, and move them 
// to fft3_tmp while multiplying with the baseband filter function
// centered at carr_center.
  z=&fft3[fft3_px+fft3_size];
  for(i=0; i<sizhalf; i++)
    {
    k=carr_center-i;
    if(k >=0)
      {
      fft3_tmp[2*i  ]=z[2*i  ]*bg_filterfunc[k];    
      fft3_tmp[2*i+1]=z[2*i+1]*bg_filterfunc[k];    
      }
    else  
      {  
      fft3_tmp[2*i  ]=0;    
      fft3_tmp[2*i+1]=0;    
      }
    }
  nn=2*(mix2_size-1);
  for(i=0; i<sizhalf; i++)
    {
    k=carr_center+i;
    if(k < fft3_size)
      {
      fft3_tmp[nn-2*i  ]=z[-2*i-2]*bg_filterfunc[k];    
      fft3_tmp[nn-2*i+1]=z[-2*i-1]*bg_filterfunc[k];    
      }
    else  
      {  
      fft3_tmp[nn-2*i  ]=0;    
      fft3_tmp[nn-2*i+1]=0;    
      }
    }
// Select mix2_size points centered at fft3_size/2, and move them 
// to fft3_tmp while multiplying with a filter function that is 
// bg.coh_factor times narrower than the baseband filter function
  carr=&fft3_tmp[2*mix2_size];
  for(i=0; i<sizhalf; i++)
    {
    k=fft3_size-carr_center+i;
    if(k > 0 && k < fft3_size)
      {
      carr[2*i  ]=z[2*i  ]*bg_carrfilter[k];    
      carr[2*i+1]=z[2*i+1]*bg_carrfilter[k];    
      }
    else  
      {  
      carr[2*i  ]=0;    
      carr[2*i+1]=0;    
      }
    }
  for(i=0; i<sizhalf; i++)
    {
    k=fft3_size-carr_center-i;
    if(k > 0 && k < fft3_size)
      {
      carr[nn-2*i  ]=z[-2*i-2]*bg_carrfilter[k];    
      carr[nn-2*i+1]=z[-2*i-1]*bg_carrfilter[k];    
      }
    else  
      {  
      carr[nn-2*i  ]=0;    
      carr[nn-2*i+1]=0;    
      }
    }
// fft3 transforms always use a sin squared window with 50% overlapping
// transforms.    
// Place the transforms with 50% overlap and add them together. 
// sin squared + cos squared ==1
  fftback(mix2_size, mix2_n, fft3_tmp, mix2_table, mix2_permute);
  fftback(mix2_size,mix2_n, carr,mix2_table,mix2_permute);
// Store baseb_raw and baseb_carrier.
// Every second transform with reversed sign. 50% overlap because
// we are using sin squared windows.
// Compute baseb, the product of the carrier and the signal.
  zc=&baseb_carrier[2*baseb_pa];
  zr=&baseb_raw[2*baseb_pa];        
  zca=&baseb_carrier_ampl[baseb_pa];        
  z=&baseb[2*baseb_pa];        
  for(i=0; i<sizhalf; i++)
    {
    zr[2*i  ]+=fft3_tmp[2*i];     
    zr[2*i+1]+=fft3_tmp[2*i+1];     
    zc[2*i  ]+=carr[2*i  ];
    zc[2*i+1]+=carr[2*i+1];
    }
  zr=&baseb_raw[2*((baseb_pa+sizhalf)&baseband_mask)];        
  zc=&baseb_carrier[2*((baseb_pa+sizhalf)&baseband_mask)];        
  k=mix2_size;
  for(i=0; i<k; i++)
    {
    zr[i]=fft3_tmp[i+k];     
    zc[i]=carr[i+k];
    }
  }  
else
  {
// !!!!!!!!!!!!!! There are two rx channels. !!!!!!!!!!!!!!!!!!
// The desired signal should be at frequency=0 (point=fft3_size/2)
// In case AFC is enabled or a coherent processing is selected
// We take the responsibility to center the desired passband on the
// peak of the averaged fft3 spectrum.
  zp=&fft3_slowsum[-2*bg_first_xpoint];
  if( afc2_active_flag != 0)
    {
// Look for a maximum within half the flat passband.  
    mm=(1+bg_flatpoints+bg_curvpoints)/2;
    if(mm > (fft3_size>>2) )mm=fft3_size>>2;
    mm=(bg.afc2_range*mm)/100;
    if(mm == 0)mm=1;
    ia=fft3_size/2-mm;
    ib=fft3_size/2+mm;
    t1=0;
    for(i=ia; i<=ib; i++)
      {
      if(t1 < zp[2*i])
        {
        t1 = zp[2*i];
        carr_center=i;
        }
      }
// The spectrum may be very asymmetric.      
// Calculate the moment of inertia of the spectrum around the selected
// point and it's neighbours.
// Step either way to minimize it.
    t1=0;
    t2=0;
    t3=0;
    nstep=0;
    mm=(1+bg_flatpoints+bg_curvpoints)/(2*bg.coh_factor);
    for(i=1; i<=mm; i++)
      {
      k=i*i;
      t1+=k*(zp[2*(carr_center-1+i)]+zp[2*(carr_center-1-i)]);
      t2+=k*(zp[2*(carr_center  +i)]+zp[2*(carr_center  -i)]);
      t3+=k*(zp[2*(carr_center+1+i)]+zp[2*(carr_center+1-i)]);
      }
step_carrcenter_two:;    
    if(t1 < t2 && t1 < t3)
      {
      carr_center--;
      t3=t2;
      t2=t1;
      t1=0;
      for(i=1; i<=mm; i++)
        {
        k=i*i;
        t1+=k*(zp[2*(carr_center-1+i)]+zp[2*(carr_center-1-i)]);
        }
      nstep++;            
      if(nstep < mm/4)goto step_carrcenter_two;  
      }
    if(t3 < t2 && t3 < t1)
      {
      carr_center++;
      t1=t2;
      t2=t3;
      t3=0;
      for(i=1; i<=mm; i++)
        {
        k=i*i;
        t3+=k*(zp[2*(carr_center+1+i)]+zp[2*(carr_center+1-i)]);
        }
      nstep++;            
      if(nstep < mm/4)goto step_carrcenter_two;  
      }
    place_carr_indicator(carr_center);
    }
// Compute the power within several narrow filters near the passband.
// Get the average while excluding large values.
// This way occasional signals outside our filter will not
// be included in the noise floor.
  if( afc2_active_flag != 0 || genparm[CW_DECODE_ENABLE] != 0)
    {
    mm=bg_flatpoints+2*bg_curvpoints+NOISE_SEP;
    t3=BIG;
    for(k=0; k<NOISE_FILTERS; k++)
      {
      t1=0;
      t2=0;
      for(i=0; i<NOISE_POINTS; i++)
        {
        j=mm+i+k*(NOISE_POINTS+NOISE_SEP);
        t1+=zp[2*(carr_center+j)];
        t2+=zp[2*(carr_center-j)];
        }
      noise[2*k]=t1;
      noise[2*k+1]=t2;
      if(t1<t3)t3=t1;
      if(t2<t3)t3=t2;
      }
    k=0;
    t1=0;
    t3*=1.5;
    for(i=0; i<2*NOISE_FILTERS; i++)
      {
      if(noise[i] < t3)
        {
        t1+=noise[i];
        k++;
        }
      }
    noise_floor=t1/(k*NOISE_POINTS);
    }
// Select mix2_size points centered at fft3_size/2, and move them 
// to fft3_tmp while multiplying with the baseband filter function
// centered at carr_center.
// Transform the polarisation at the same time.
  z=&fft3[fft3_px+2*fft3_size];
  zp+=fft3_size;
  a2=0;
  b2=0;
  re=0;
  im=0;
  for(i=0; i<sizhalf; i++)
    {
    k=carr_center-i;
    if(k >=0 )
      {
      if(bg_filterfunc[k] == 0)
        {
        fft3_tmp[4*i  ]=0;
        fft3_tmp[4*i+1]=0;
        fft3_tmp[4*i+2]=0;
        fft3_tmp[4*i+3]=0;
        }
      else
        {  
        t1=z[4*i  ];
        t2=z[4*i+1];
        t3=z[4*i+2];
        t4=z[4*i+3];
        fft3_tmp[4*i  ]=(pg.c1*t1+pg.c2*t3+pg.c3*t4)*bg_filterfunc[k];
        fft3_tmp[4*i+1]=(pg.c1*t2+pg.c2*t4-pg.c3*t3)*bg_filterfunc[k];
        fft3_tmp[4*i+2]=(pg.c1*t3-pg.c2*t1+pg.c3*t2)*bg_filterfunc[k];
        fft3_tmp[4*i+3]=(pg.c1*t4-pg.c2*t2-pg.c3*t1)*bg_filterfunc[k];
        r1=P4SCALE*(zp[2*i]-noise_floor);
        if(r1 > 0  && pg.adapt == 0)
          {
          a2+=r1*(fft3_tmp[4*i  ]*fft3_tmp[4*i  ]+
                  fft3_tmp[4*i+1]*fft3_tmp[4*i+1]);
          b2+=r1*(fft3_tmp[4*i+2]*fft3_tmp[4*i+2]+
                  fft3_tmp[4*i+3]*fft3_tmp[4*i+3]);
          re+=r1*(fft3_tmp[4*i  ]*fft3_tmp[4*i+2]+
                  fft3_tmp[4*i+1]*fft3_tmp[4*i+3]);
          im+=r1*(-fft3_tmp[4*i  ]*fft3_tmp[4*i+3]+
                   fft3_tmp[4*i+1]*fft3_tmp[4*i+2]);
          }
        }
      }
    else  
      {  
      fft3_tmp[4*i  ]=0;    
      fft3_tmp[4*i+1]=0;    
      fft3_tmp[4*i+2]=0;    
      fft3_tmp[4*i+3]=0;    
      }
    }
  nn=4*(mix2_size-1);
  for(i=0; i<sizhalf; i++)
    {
    k=carr_center+i;
    if(k<fft3_size)
      {
      if(bg_filterfunc[k] == 0)
        {
        fft3_tmp[nn-4*i  ]=0;
        fft3_tmp[nn-4*i+1]=0;
        fft3_tmp[nn-4*i+2]=0;
        fft3_tmp[nn-4*i+3]=0;
        }
      else
        {  
        t1=z[-4*i-4];
        t2=z[-4*i-3];
        t3=z[-4*i-2];
        t4=z[-4*i-1];
        fft3_tmp[nn-4*i  ]=(pg.c1*t1+pg.c2*t3+pg.c3*t4)*bg_filterfunc[k];
        fft3_tmp[nn-4*i+1]=(pg.c1*t2+pg.c2*t4-pg.c3*t3)*bg_filterfunc[k];
        fft3_tmp[nn-4*i+2]=(pg.c1*t3-pg.c2*t1+pg.c3*t2)*bg_filterfunc[k];
        fft3_tmp[nn-4*i+3]=(pg.c1*t4-pg.c2*t2-pg.c3*t1)*bg_filterfunc[k];
        r1=P4SCALE*(zp[-2*i]-noise_floor);
        if(r1 > 0  && pg.adapt == 0)
          {
          a2+=r1*(fft3_tmp[nn-4*i  ]*fft3_tmp[nn-4*i  ]+
                  fft3_tmp[nn-4*i+1]*fft3_tmp[nn-4*i+1]);
          b2+=r1*(fft3_tmp[nn-4*i+2]*fft3_tmp[nn-4*i+2]+
                  fft3_tmp[nn-4*i+3]*fft3_tmp[nn-4*i+3]);
          re+=r1*(fft3_tmp[nn-4*i  ]*fft3_tmp[nn-4*i+2]+
                  fft3_tmp[nn-4*i+1]*fft3_tmp[nn-4*i+3]);
          im+=r1*(-fft3_tmp[nn-4*i  ]*fft3_tmp[nn-4*i+3]+
                   fft3_tmp[nn-4*i+1]*fft3_tmp[nn-4*i+2]);
          }
        }
      }
    else  
      {  
      fft3_tmp[nn-4*i  ]=0;    
      fft3_tmp[nn-4*i+1]=0;    
      fft3_tmp[nn-4*i+2]=0;    
      fft3_tmp[nn-4*i+3]=0;    
      }
    }
// In case the polarisation is already correct, a2 is large because
// it is S+N while the other numbers are small, containing noise only.
// Now, to follow the polarisation correctly for really weak
// signals do not just use the data as they come here.
// Store the result in poleval_data and adjust pol first when it
// is quite certain that a new set of coefficients is better. 
  if(pg.adapt != 0)goto good_poldata;
  poleval_data[poleval_pointer].a2=a2;
  poleval_data[poleval_pointer].b2=b2;
  poleval_data[poleval_pointer].re=re;
  poleval_data[poleval_pointer].im=im;
  for(i=0; i<poleval_pointer; i++)
    {
    a2+=poleval_data[i].a2;
    b2+=poleval_data[i].b2;
    re+=poleval_data[i].re;
    im+=poleval_data[i].im;
    }
  poleval_pointer++;  
  if(poleval_pointer<POLEVAL_SIZE/5)goto good_poldata;
// Check afcsub.c or blank1 .c for an explanation how pol 
// coefficients are calculated.
// If we shall change pol coefficients now, we must be sure that
// the phase angle between a and b is accurate.
// Step through the data and sum the square of the phase deviation.
// Note that the phase is two dimensional. 
// The angle between polarisation planes and the phase angle 
// between voltages. 
  t1=a2+b2;
  if(t1 == 0)goto bad_poldata;
  a2/=t1;
  b2/=t1;
  re/=t1;
  im/=t1;
  r1=0;
  r2=0;
  for(i=0; i<poleval_pointer; i++)
    {
    t1=poleval_data[i].a2+poleval_data[i].b2;
    t2=re*t1;
    t3=im*t1;
    r1+=poleval_data[i].re*poleval_data[i].re+
        poleval_data[i].im*poleval_data[i].im;
    r2+=-(t2-poleval_data[i].re)*(t2-poleval_data[i].re)+
        (t3-poleval_data[i].im)*(t3-poleval_data[i].im);
    }
  r2/=r1;
  if(r2 >0.2)goto bad_poldata;
  t2=re*re+im*im;
  noi2=a2*b2-t2;
  if(noi2 > 0.12)goto bad_poldata;
  a2s=a2-noi2;
  b2s=b2-noi2;
  if(b2s <=0.0001 || t2 == 0)
    {
    poleval_pointer=0;
    goto good_poldata; 
    }
  if(a2s > 0)
    {
    c1=sqrt(a2s);
    sina=sqrt(b2s);
    c2=sina*re/sqrt(t2);
    c3=-sina*im/sqrt(t2);
    t1=sqrt(c1*c1+c2*c2+c3*c3);
    if(c2 < 0)t1=-t1;
    c1/=t1;
    c2/=t1;
    c3/=t1;
    }
  else
    {
    c1=0;
    c2=1;
    c3=0;
    }    
// The current a and b signals were produced by:
// re_a=pg.c1*re_x+pg.c2*re_y+pg.c3*im_y (1)
// im_a=pg.c1*im_x+pg.c2*im_y-pg.c3*re_y (2)
// re_b=pg.c1*re_y-pg.c2*re_x+pg.c3*im_x (3)
// im_b=pg.c1*im_y-pg.c2*im_x-pg.c3*re_x (4)
// We have now found that improved a and b signals will be obtained from:
// new_re_a=c1*re_a+c2*re_b+c3*im_b (5)
// new_im_a=c1*im_a+c2*im_b-c3*re_b (6)
// new_re_b=c1*re_b-c2*re_a+c3*im_a (7)
// new_im_b=c1*im_b-c2*im_a-c3*re_a (8)
// Eliminate the old a and b signals
// new_re_a=c1*(pg.c1*re_x+pg.c2*re_y+pg.c3*im_y)
//         +c2*(pg.c1*re_y-pg.c2*re_x+pg.c3*im_x)
//         +c3*(pg.c1*im_y-pg.c2*im_x-pg.c3*re_x)
// new_re_a=c1*pg.c1*re_x+c1*pg.c2*re_y+c1*pg.c3*im_y
//         +c2*pg.c1*re_y-c2*pg.c2*re_x+c2*pg.c3*im_x
//         +c3*pg.c1*im_y-c3*pg.c2*im_x-c3*pg.c3*re_x
// new_re_a=(c1*pg.c1-c2*pg.c2-c3*pg.c3)*re_x
//         -(c3*pg.c2-c2*pg.c3)*im_x
//         +(c1*pg.c2+c2*pg.c1)*re_y
//         +(c1*pg.c3+c3*pg.c1)*im_y
  t1=c1*pg.c1-c2*pg.c2-c3*pg.c3;
  t2=c3*pg.c2-c2*pg.c3;
  t3=c1*pg.c2+c2*pg.c1;
  t4=c1*pg.c3+c3*pg.c1;
// We want t2 to be zero so we adjust the phase.
  c1=sqrt(t1*t1+t2*t2);
  r2=sqrt(t3*t3+t4*t4);
  r1=atan2(t3,t4)+atan2(t1,t2);
  c2=-r2*cos(r1);
  c3=r2*sin(r1);
  t1=sqrt(c1*c1+c2*c2+c3*c3);
  t2=c1*pg.c1+c2*pg.c2+c3*pg.c3;
  if(t2 < 0)t1=-t1;
  c1/=t1;
  c2/=t1;
  c3/=t1;
  t1=pg.avg-1;
  pg.c1=(t1*pg.c1+c1)/pg.avg;
  pg.c2=(t1*pg.c2+c2)/pg.avg;
  pg.c3=(t1*pg.c3+c3)/pg.avg;
  t1=sqrt(pg.c1*pg.c1+pg.c2*pg.c2+pg.c3*pg.c3)+0.000001;
  if(pg.c2 < 0)t1=-t1;
  pg.c1/=t1;
  pg.c2/=t1;
  pg.c3/=t1;
  sc[SC_SHOW_POL]++;
  poleval_pointer=0;
  goto good_poldata;
bad_poldata:;
  if(poleval_pointer > 3*POLEVAL_SIZE/4)
    {
    j=poleval_pointer;
    k=POLEVAL_SIZE/4;
    poleval_pointer=0;
    for(i=k; i<j; i++)
      {
      poleval_data[poleval_pointer].a2=poleval_data[poleval_pointer+k].a2;
      poleval_data[poleval_pointer].b2=poleval_data[poleval_pointer+k].b2;
      poleval_data[poleval_pointer].re=poleval_data[poleval_pointer+k].re;
      poleval_data[poleval_pointer].im=poleval_data[poleval_pointer+k].im;
      poleval_pointer++;
      }
    }        
good_poldata:;
// Select mix2_size points centered at fft3_size/2, and move them 
// to fft3_tmp while multiplying with a filter function that is 
// bg.coh_factor times narrower than the baseband filter function
// Just process the first polarisation. 
// The user is responsible for the polarisation to be right!
  carr=&fft3_tmp[4*mix2_size];
  nn=2*(mix2_size-1);
  for(i=0; i<sizhalf; i++)
    {
    k=fft3_size-carr_center+i;
    if(k > 0 && k < fft3_size)
      {
      carr[2*i  ]=fft3_tmp[4*i  ]*bg_carrfilter[k];    
      carr[2*i+1]=fft3_tmp[4*i+1]*bg_carrfilter[k];    
      }
    else  
      {  
      carr[2*i  ]=0;    
      carr[2*i+1]=0;    
      }
    }
  for(i=0; i<sizhalf; i++)
    {
    k=fft3_size-carr_center-i;
    if(k > 0 && k < fft3_size)
      {
      carr[nn-2*i  ]=fft3_tmp[2*nn-4*i  ]*bg_carrfilter[k];    
      carr[nn-2*i+1]=fft3_tmp[2*nn-4*i+1]*bg_carrfilter[k];    
      }
    else  
      {  
      carr[nn-2*i  ]=0;    
      carr[nn-2*i+1]=0;    
      }
    }
// fft3 transforms always use a sin squared window with 50% overlapping
// transforms.    
// Place the back transforms with 50% overlap and add them together. 
// sin squared + cos squared ==1
  dual_fftback(mix2_size, mix2_n, fft3_tmp, mix2_table, mix2_permute);
  fftback(mix2_size,mix2_n, carr,mix2_table,mix2_permute);
// Store baseb_raw, baseb_raw_orthog and baseb_carrier.
// Every second transform with reversed sign. 50% overlap because
// we are using sin squared windows.
  zc=&baseb_carrier[2*baseb_pa];
  zr=&baseb_raw[2*baseb_pa];        
  zb=&baseb_raw_orthog[2*baseb_pa];
  for(i=0; i<sizhalf; i++)
    {
    zr[2*i  ]+=fft3_tmp[4*i  ];     
    zr[2*i+1]+=fft3_tmp[4*i+1];     
    zb[2*i  ]+=fft3_tmp[4*i+2];     
    zb[2*i+1]+=fft3_tmp[4*i+3];     
    zc[2*i  ]+=carr[2*i  ];
    zc[2*i+1]+=carr[2*i+1];
    }
  k=sizhalf;
  zr=&baseb_raw[2*((baseb_pa+sizhalf)&baseband_mask)];        
  zb=&baseb_raw_orthog[2*((baseb_pa+sizhalf)&baseband_mask)];        
  zc=&baseb_carrier[2*((baseb_pa+sizhalf)&baseband_mask)];        
  for(i=0; i<sizhalf; i++)
    {
    zr[2*i  ]=fft3_tmp[4*(i+k)  ];     
    zr[2*i+1]=fft3_tmp[4*(i+k)+1];     
    zb[2*i  ]=fft3_tmp[4*(i+k)+2];     
    zb[2*i+1]=fft3_tmp[4*(i+k)+3];     
    zc[2*i  ]=carr[2*(i+k)  ];
    zc[2*i+1]=carr[2*(i+k)+1];
    }
  }
if(genparm[CW_DECODE_ENABLE] != 0)
  {
// We want cw decoding. Compute baseb_wb_raw, a signal with a bandwidth
// that is at least two times bigger than the bandwidth of the
// filtered signal. (see computation of baseband_sampling_speed in
// baseb_graph.c)
  if(sw_onechan)
    {
    z=&fft3[fft3_px+fft3_size];
    for(i=0; i<sizhalf; i++)
      {
      fft3_tmp[2*i  ]=z[2*i  ];    
      fft3_tmp[2*i+1]=z[2*i+1];    
      }
    nn=2*(mix2_size-1);
    for(i=0; i<sizhalf; i++)
      {
      fft3_tmp[nn-2*i  ]=z[-2*i-2];    
      fft3_tmp[nn-2*i+1]=z[-2*i-1];    
      }
    }
  else
    {
// !!!!!!!!!!!!!! There are two rx channels. !!!!!!!!!!!!!!!!!!
// Select mix2_size points centered at fft3_size/2, and move them 
// to fft3_tmp. Transform the polarisation at the same time.
    z=&fft3[fft3_px+2*fft3_size];
    for(i=0; i<sizhalf; i++)
      {
      fft3_tmp[2*i  ]=pg.c1*z[4*i  ]+pg.c2*z[4*i+2]+pg.c3*z[4*i+3];
      fft3_tmp[2*i+1]=pg.c1*z[4*i+1]+pg.c2*z[4*i+3]-pg.c3*z[4*i+2];
      }
    nn=2*(mix2_size-1);
    for(i=0; i<sizhalf; i++)
      {
      fft3_tmp[nn-2*i  ]=pg.c1*z[-4*i-4]+pg.c2*z[-4*i-2]+pg.c3*z[-4*i-1];
      fft3_tmp[nn-2*i+1]=pg.c1*z[-4*i-3]+pg.c2*z[-4*i-1]-pg.c3*z[-4*i-2];
      }
    }
  fftback(mix2_size, mix2_n, fft3_tmp, mix2_table, mix2_permute);
// Store baseb_wb_raw
// Every second transform with reversed sign. 50% overlap because
// we are using sin squared windows.
  zw=&baseb_wb_raw[2*baseb_pa];
  for(i=0; i<sizhalf; i++)
    {
    zw[2*i  ]+=fft3_tmp[2*i  ];
    zw[2*i+1]+=fft3_tmp[2*i+1];
    }
  k=sizhalf;
  zw=&baseb_wb_raw[2*((baseb_pa+sizhalf)&baseband_mask)];        
  for(i=0; i<sizhalf; i++)
    {
    zw[2*i  ]=fft3_tmp[2*(i+k)  ];
    zw[2*i+1]=fft3_tmp[2*(i+k)+1];
    }
  }
last_point=(baseb_pa+sizhalf)&baseband_mask;
ampfac=cg_size*daout_gain/bg_amplimit;
// *******************************************************************
// Calculate the amplitude of the signal and the amplitude of the carrier.
// Store sines and cosines of the carrier phase.
// Make an I/Q demodulator using the carrier phase.
// Use this "zero level" coherent detect data to make the upper coherent
// graph that will help the user select coherence ratio for unstable
// signals.
t2=0;
t5=0;
cg_mid=cg_size/2;
big=0.499*cg_size;
ia=baseb_pa;
i=(baseb_pa+baseband_mask)&baseband_mask;
if(genparm[CW_DECODE_ENABLE] != 0 || bg.agc_flag == 1)
  {
  t2=baseb_upthreshold[i];
  }
if(bg.agc_flag == 2)
  {
  t2=baseb_upthreshold[2*i  ];
  t5=baseb_upthreshold[2*i+1];
  }
t3=0;
t4=0;
while(ia != last_point)
  {
  baseb_totpwr[ia]=baseb_raw[2*ia  ]*baseb_raw[2*ia  ]+
                   baseb_raw[2*ia+1]*baseb_raw[2*ia+1];
  t4+=baseb_totpwr[ia];
  if(t3 < baseb_totpwr[ia])t3=baseb_totpwr[ia];
  baseb_carrier_ampl[ia]=sqrt(baseb_carrier[2*ia  ]*baseb_carrier[2*ia  ]+
                              baseb_carrier[2*ia+1]*baseb_carrier[2*ia+1]);
  if(genparm[CW_DECODE_ENABLE] != 0 || bg.agc_flag == 1)
    {
    t2*=cg_decay_factor;
    if(t2 < baseb_totpwr[ia])t2=baseb_totpwr[ia];
    baseb_upthreshold[ia]=t2;
    }
  if(baseb_carrier_ampl[ia]==0)
    {
    baseb_carrier_ampl[ia]=0.0000000000001;
    }
  else
    {   
    baseb_carrier[2*ia  ]/=baseb_carrier_ampl[ia];
    baseb_carrier[2*ia+1]/=baseb_carrier_ampl[ia];
    }
  baseb[2*ia  ]=baseb_carrier[2*ia  ]*baseb_raw[2*ia  ]+
                baseb_carrier[2*ia+1]*baseb_raw[2*ia+1];
  baseb[2*ia+1]=baseb_carrier[2*ia  ]*baseb_raw[2*ia+1]-
                baseb_carrier[2*ia+1]*baseb_raw[2*ia  ];
  if(bg.agc_flag == 2)
    {
    baseb[2*ia  ]-=baseb_carrier_ampl[ia];
    t2*=cg_decay_factor;
    if(t2 < baseb[2*ia  ]*baseb[2*ia  ])t2=baseb[2*ia  ]*baseb[2*ia  ];
    baseb_upthreshold[2*ia  ]=t2;
    t5*=cg_decay_factor;
    if(t5 < baseb[2*ia+1]*baseb[2*ia+1])t5=baseb[2*ia+1]*baseb[2*ia+1];
    baseb_upthreshold[2*ia+1]=t5;
    }
  r1=ampfac*baseb[2*ia  ];
  r2=ampfac*baseb[2*ia+1];
  if(genparm[CW_DECODE_ENABLE] != 0)
    {
    baseb_fit[2*ia  ]=0;
    baseb_fit[2*ia+1]=0;
    baseb_envelope[2*ia  ]=0;
    baseb_envelope[2*ia+1]=0;
    }
  ia=(ia+1)&baseband_mask;
  if(fabs(r1)>big || fabs(r2)>big)
    {
    t1=big/sqrt(r1*r1+r2*r2);
    r1*=t1;
    r2*=t1;
    }
  ix=cg_mid+r1;
  iy=cg_mid+r2;
  cg_map[iy*cg_size+ix]+=1;
  }
basblock_maxpower[basblock_pa]=t3;
basblock_avgpower[basblock_pa]=t4/sizhalf;
basblock_pa=(basblock_pa+1)&basblock_mask;
// **********************************************************
// If morse decoding is enabled, compute the fourier transform
// of the real part of baseb_wb. Since this array is not needed
// for any other purpose, we do not store it so its real part
// is computed from baseb_carrier and baseb_wb_raw.
// The phase is zero in good
// regions where the carrier is correct. Use the level of the
// carrier as a weight factor to suppress regions where
// the signal is likely to be absent or incorrect.
if(genparm[CW_DECODE_ENABLE] != 0)
  {
  if(fft3_slowsum_cnt < 1){lirerr(341296);return;}
  noise_floor*=2.818/fft3_slowsum_cnt;
  baseband_noise_level=noise_floor*bgfil_weight;
  carrier_noise_level=noise_floor*carrfil_weight;
  ia=(baseb_pa-sizhalf+baseband_size)&baseband_mask;
  i=0;
  while(ia != last_point)
    {
    t1=baseb_carrier_ampl[ia]*baseb_carrier_ampl[ia];
    if(t1 > 0)
      {
      mix2_tmp[2*i]=P4SCALE*(baseb_carrier[2*ia  ]*baseb_wb_raw[2*ia  ]+
                             baseb_carrier[2*ia+1]*baseb_wb_raw[2*ia+1])*
                             sqrt(t1)*mix2_window[i];
      }
    else
      {
      mix2_tmp[2*i  ]=0;
      }
    mix2_tmp[2*i+1]=0;
    ia=(ia+1)&baseband_mask;
    i++;
    }
  fftforward(mix2_size, mix2_n, mix2_tmp, mix2_table, mix2_permute);
// The fourier transform here should have been computed
// with a real to hermitian fft implementation. Just filling
// the complex part with zeroes is inefficient.
//
// The keying spectra arrive at a rate of 2*baseband_sampling_speed/mix2_size.
// Accumulate power spectra in a leaky integrator that has a life time
// of 15 seconds.
  t2=1-keying_spectrum_f1;
  keying_spectrum_cnt++;
  for(i=0; i<keying_spectrum_size; i++)
    {
    keying_spectrum[i]=keying_spectrum_f1*keying_spectrum[i]+
                   t2*(pow(mix2_tmp[2*i  ],2.0)+pow(mix2_tmp[2*i+1],2.0));
    }
  sc[SC_SHOW_KEYING_SPECTRUM]++;
  }
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
cg_update_count++;
if(cg_update_count > cg_update_interval)
  {
  sc[SC_SHOW_COHERENT]++;
  cg_update_count=0;
  }
// Make data for the S-meter graph.
if(mg.avgnum > 0)
  {
  j=((last_point-baseb_pm+baseband_mask)&baseband_mask)/mg.avgnum;
  if(j > 0)
    {
    sellim_correction=1;  
    if(genparm[SECOND_FFT_ENABLE] != 0)
      {
      if(!swfloat)
        {
        ia=mix1_selfreq[0]*mix1_points_per_hz;
        ia/=fft2_to_fft1_ratio;
        if(liminfo[ia]>0)
          {
          sellim_correction=1/pow(liminfo[ia],2.0);
          }
        }
      }
    fac=baseband_pwrfac*sellim_correction;  
    for(i=0; i<j; i++)
      {
      t1=0.000000001;
      t2=0.000000001;
      ia=(baseb_pm+mg.avgnum)&baseband_mask;
      if(sw_onechan)
        {
        while(baseb_pm != ia)
          {
          t1+=baseb_totpwr[baseb_pm];
          if(t2 < baseb_totpwr[baseb_pm])t2=baseb_totpwr[baseb_pm];
          baseb_pm=(baseb_pm+1)&baseband_mask;
          }
        mg_rms_meter[mg_pa]=log10(fac*t1/mg.avgnum);      
        mg_peak_meter[mg_pa]=log10(fac*t2);      
        }
      else
        {  
        t3=0.000000001;
        t4=0.000000001;
        while(baseb_pm != ia)
          {
          t1+=baseb_totpwr[baseb_pm];
          if(t2 < baseb_totpwr[baseb_pm])t2=baseb_totpwr[baseb_pm];
          r1=baseb_raw_orthog[2*baseb_pm  ]*baseb_raw_orthog[2*baseb_pm  ]+
             baseb_raw_orthog[2*baseb_pm+1]*baseb_raw_orthog[2*baseb_pm+1];
          t3+=r1;
          if(t4 < r1)t4=r1;
          baseb_pm=(baseb_pm+1)&baseband_mask;
          }
        mg_rms_meter[2*mg_pa  ]=log10(fac*t1/mg.avgnum);      
        mg_rms_meter[2*mg_pa+1]=log10(fac*t3/mg.avgnum);      
        mg_peak_meter[2*mg_pa  ]=log10(fac*t2);      
        mg_peak_meter[2*mg_pa+1]=log10(fac*t4);      
        }
      mg_pa=(mg_pa+1)&mg_mask;
      mg_valid++;    
      }
    if(cg.meter_graph_on != 0)sc[SC_UPDATE_METER_GRAPH]++;
    }
  }  
if(mg_valid > mg_size)mg_valid=mg_size;  
// baseb_upthreshold is a fast attack, slow release signal follower 
// to baseb_totpwr. Make a fast attack, slow release signal
// follower in the reverse direction and store the largest of the 
// forward and backward peak detector -6dB in baseb_threshold.
ia=last_point;
ib=(baseb_pa+baseband_mask)&baseband_mask;
t2=0;
t5=0;
k=2;
ic=baseb_pb;
while(k!=0 && ia!=ic)
  {
  if(ia == ib)
    {
    k=1;
    }
  else
    {
    k|=1;
    }
  ia=(ia+baseband_mask)&baseband_mask;
  if(genparm[CW_DECODE_ENABLE] != 0 || bg.agc_flag == 1)
    {
    t2*=cg_decay_factor;
    if(t2 < baseb_totpwr[ia])
      {
      t2=baseb_totpwr[ia];
      }
    t1=t2;
    if(t1<baseb_upthreshold[ia])
      {
      t1=baseb_upthreshold[ia];
      }
    else
      {
      k&=2;
      }
    baseb_threshold[ia]=0.25*t1;
    }
  if(bg.agc_flag == 2)
    {
    t2*=cg_decay_factor;
    if(t2 < baseb[2*ia]*baseb[2*ia])
      {
      t2=baseb[2*ia]*baseb[2*ia];
      }
    t1=t2;
    if(t1<baseb_upthreshold[2*ia])
      {
      t1=baseb_upthreshold[2*ia];
      }
    else
      {
      k&=2;
      }
    baseb_threshold[2*ia]=0.25*t1;
    t5*=cg_decay_factor;
    if(t5 < baseb[2*ia+1]*baseb[2*ia+1])
      {
      t5=baseb[2*ia+1]*baseb[2*ia+1];
      }
    t1=t5;
    if(t1<baseb_upthreshold[2*ia+1])
      {
      t1=baseb_upthreshold[2*ia+1];
      }
    else
      {
      k&=2;
      }
    baseb_threshold[2*ia+1]=0.25*t1;
    }
  }
if(bg.agc_flag == 1)
  {
  while(ia != last_point)
    {
    rx_agc_sumpow1=agc_attack_factor1*rx_agc_sumpow1+
                           agc_attack_factor2*baseb_threshold[ia];
    rx_agc_sumpow2=agc_attack_factor1*rx_agc_sumpow2+
                                 agc_attack_factor2*rx_agc_sumpow1;
    rx_agc_factor1*=agc_release_factor;
    if(rx_agc_factor1 < rx_agc_sumpow2)
      {
      rx_agc_factor1=rx_agc_sumpow2;
      }
    baseb_agc_level[ia]=sqrt(rx_agc_factor1);
    ia=(ia+1)&baseband_mask;
    }
  }
if(bg.agc_flag == 2)
  {
  while(ia != last_point)
    {
    rx_agc_sumpow1=agc_attack_factor1*rx_agc_sumpow1+
                           agc_attack_factor2*baseb_threshold[2*ia];
    rx_agc_sumpow2=agc_attack_factor1*rx_agc_sumpow2+
                                 agc_attack_factor2*rx_agc_sumpow1;
    rx_agc_factor1*=agc_release_factor;
    rx_agc_factor1*=agc_release_factor;
    if(rx_agc_factor1 < rx_agc_sumpow2)
      {
      rx_agc_factor1=rx_agc_sumpow2;
      }
    baseb_agc_level[2*ia]=sqrt(rx_agc_factor1);
    rx_agc_sumpow3=agc_attack_factor1*rx_agc_sumpow3+
                           agc_attack_factor2*baseb_threshold[2*ia+1];
    rx_agc_sumpow4=agc_attack_factor1*rx_agc_sumpow4+
                               agc_attack_factor2*rx_agc_sumpow3;
    rx_agc_factor2*=agc_release_factor;
    if(rx_agc_factor2 < rx_agc_sumpow4)
      {
      rx_agc_factor2=rx_agc_sumpow4;
      }
    baseb_agc_level[2*ia+1]=sqrt(rx_agc_factor2);
    ia=(ia+1)&baseband_mask;
    }
  }
n=(last_point-baseb_pb+baseband_size)&baseband_mask;
last_point=(baseb_pa+sizhalf-(int)(10*cg_code_unit)+baseband_size)&baseband_mask;
// Put whatever output the operator asked for in baseb_out    
zc=&baseb_carrier[2*baseb_pa];
zca=&baseb_carrier_ampl[baseb_pa];        
zr=&baseb_raw[2*baseb_pa];        
zb=&baseb_raw_orthog[2*baseb_pa];
z=&baseb[2*baseb_pa];
if(bg_delay != 0)
  {
// Synthetic stereo from mono by time delay of one channel is selected.  
// just send data direct and delayed. Do not worry about orthog
// if we have two channels.
  zo=&baseb_out[4*baseb_pa];        
  pb=(baseb_pa+bg.delay_points)&baseband_mask;
  if(use_bfo != 0)
    {
    for(i=0; i<sizhalf; i++)
      {
      baseb_out[4*pb  ]=zr[2*i];
      zo[4*i+2]=zr[2*i];     
      baseb_out[4*pb+1]=zr[2*i+1];
      zo[4*i+3]=zr[2*i+1];      
      pb=(pb+1)&baseband_mask;
      }
    }
  else
    {    
    if(rx_mode == MODE_AM)
      {
      za=&baseb_totpwr[baseb_pa];
      for(i=0; i<sizhalf; i++)
        {
        t1=sqrt(za[i]);
        am_dclevel1=am_dclevel1*am_dclevel_factor1+t1*am_dclevel_factor2;
        baseb_out[4*pb  ]=t1-am_dclevel1;     
        zo[4*i+2]=t1-am_dclevel1;     
        baseb_out[4*pb+1]=0;
        zo[4*i+3]=0;      
        pb=(pb+1)&baseband_mask;
        }
      }  
    else
      {
// The user selected FM. Make an FM detector.
      za=&baseb_totpwr[baseb_pa];
      for(i=0; i<sizhalf; i++)
        {
        t2=am_dclevel1;
        t1=atan2(zr[2*i+1],zr[2*i]);
        am_dclevel1=t1;
        t1-=t2;
        if(t1 > PI_L)t1-=2*PI_L;                
        if(t1 < -PI_L)t1+=2*PI_L;                
        t1*=1000;
        baseb_out[4*pb  ]=t1;     
        zo[4*i+2]=t1;     
        baseb_out[4*pb+1]=0;
        zo[4*i+3]=0;      
        pb=(pb+1)&baseband_mask;
        }
      }   
    }
  }
else  
  {
  switch (bg_coherent)
    {     
    case 0:
// No fancy processing at all. 
// Just store signal as it is or with a detector to fit the current mode.
    if(use_bfo != 0)
      {
      if(sw_onechan || bg_twopol == 0)
        {
        zo=&baseb_out[2*baseb_pa];        
        for(i=0; i<sizhalf; i++)
          {
          zo[2*i  ]=zr[2*i];     
          zo[2*i+1]=zr[2*i+1];     
          }
        }  
      else    
        {
        zo=&baseb_out[4*baseb_pa];        
        for(i=0; i<sizhalf; i++)
          {
          zo[4*i  ]=zr[2*i  ];     
          zo[4*i+1]=zr[2*i+1];     
          zo[4*i+2]=zb[2*i  ];     
          zo[4*i+3]=zb[2*i+1];     
          }
        }
      }
    else
      {  
      if(rx_mode == MODE_AM)
        {
        za=&baseb_totpwr[baseb_pa];
// The user selected AM. Make amplitude detection.
        if(sw_onechan || bg_twopol == 0)
          {
          zo=&baseb_out[2*baseb_pa];        
          for(i=0; i<sizhalf; i++)
            {
            t1=sqrt(za[i]);
            am_dclevel1=am_dclevel1*am_dclevel_factor1+t1*am_dclevel_factor2;
            zo[2*i  ]=t1-am_dclevel1;     
            zo[2*i+1]=0;     
            }
          }  
        else    
          {
          zo=&baseb_out[4*baseb_pa];        
          for(i=0; i<sizhalf; i++)
            {
            t1=sqrt(za[i]);
            am_dclevel1=am_dclevel1*am_dclevel_factor1+t1*am_dclevel_factor2;
            zo[4*i  ]=t1-am_dclevel1;     
            zo[4*i+1]=0;     
            t1=sqrt(zb[2*i]*zb[2*i]+zb[2*i+1]*zb[2*i+1]);
            am_dclevel2=am_dclevel2*am_dclevel_factor1+t1*am_dclevel_factor2;
            zo[4*i+2]=t1-am_dclevel2;     
            zo[4*i+3]=0;     
            }
          }
        }
      else
        {
// The user selected FM. Make an FM detector.
        if(sw_onechan || bg_twopol == 0)
          {
          zo=&baseb_out[2*baseb_pa];        
          for(i=0; i<sizhalf; i++)
            {
            t2=am_dclevel1;
            t1=atan2(zr[2*i+1],zr[2*i]);
            am_dclevel1=t1;
            t1-=t2;
            if(t1 > PI_L)t1-=2*PI_L;                
            if(t1 < -PI_L)t1+=2*PI_L;                
            t1*=1000;
            zo[2*i]=t1;     
            zo[2*i+1]=0;      
            }
          }
        else
          {
          zo=&baseb_out[4*baseb_pa];        
          for(i=0; i<sizhalf; i++)
            {
            t2=am_dclevel1;
            t1=atan2(zr[2*i+1],zr[2*i]);
            am_dclevel1=t1;
            t1-=t2;
            if(t1 > PI_L)t1-=2*PI_L;                
            if(t1 < -PI_L)t1+=2*PI_L;                
            t1*=1000;
            zo[4*i]=t1;     
            zo[4*i+1]=0;      
            t2=am_dclevel2;
            t1=atan2(zb[2*i+1],zb[2*i]);
            am_dclevel2=t1;
            t1-=t2;
            if(t1 > PI_L)t1-=2*PI_L;                
            if(t1 < -PI_L)t1+=2*PI_L;                
            t1*=1000;
            zo[4*i+2]=t1;     
            zo[4*i+3]=0;      
            }
          }
        }  
      }
    break;       

    case 1:
// Send the signal to one ear, the carrier to the other.
    zo=&baseb_out[4*baseb_pa];        
    if(use_bfo != 0)
      {
      for(i=0; i<sizhalf; i++)
        {
        zo[4*i  ]=zr[2*i];     
        zo[4*i+1]=zr[2*i+1];     
        zo[4*i+2]=zc[2*i  ]*zca[i];     
        zo[4*i+3]=zc[2*i+1]*zca[i];     
        }
      }
    else
      {
      if(rx_mode == MODE_AM)
        {
        za=&baseb_totpwr[baseb_pa];
// The user selected AM. Make amplitude detection.
// Here it is possible to listen to AM in two separate filters.
        for(i=0; i<sizhalf; i++)
          {
          t1=sqrt(za[i]);
          am_dclevel1=am_dclevel1*am_dclevel_factor1+t1*am_dclevel_factor2;
          zo[4*i  ]=t1-am_dclevel1;     
          zo[4*i+1]=0;     
          t1=sqrt(zca[i]);
          am_dclevel2=am_dclevel2*am_dclevel_factor1+t1*am_dclevel_factor2;
          zo[4*i+2]=t1-am_dclevel2;     
          zo[4*i+3]=0;     
          }
        }
      else
        {
// The user selected FM. 
// Here it is possible to listen to FM in two separate filters.
        for(i=0; i<sizhalf; i++)
          {
          t2=am_dclevel1;
          t1=atan2(zr[2*i+1],zr[2*i]);
          am_dclevel1=t1;
          t1-=t2;
          if(t1 > PI_L)t1-=2*PI_L;                
          if(t1 < -PI_L)t1+=2*PI_L;                
          t1*=1000;
          zo[4*i]=t1;     
          zo[4*i+1]=0;      
          t2=am_dclevel2;
          t1=atan2(zc[2*i+1],zc[2*i]);
          am_dclevel2=t1;
          t1-=t2;
          if(t1 > PI_L)t1-=2*PI_L;                
          if(t1 < -PI_L)t1+=2*PI_L;                
          t1*=1000;
          zo[4*i+2]=t1;     
          zo[4*i+3]=0;      
          pb=(pb+1)&baseband_mask;
          }
        }  
      }    
    break;

    case 2:
// Use the carrier phase to make I/Q demodulator.
// We already did it in the coherent function so just use the data.
// Send I to one ear, Q to the other.
// This means that we send AM modulation to one ear, FM modulation to
// the other ear.
// To detect FM this way, the carrier filter must be narrower than
// the modulation to be detected.
// The carrier also has to be stronger than the modulation sidebands
// which will typically not be the case!!.
    zo=&baseb_out[4*baseb_pa];        
    if(rx_mode == MODE_AM)
      {
      for(i=0; i<sizhalf; i++)
        {
        am_dclevel1=am_dclevel1*am_dclevel_factor1+z[2*i  ]*am_dclevel_factor2;
        zo[4*i  ]=z[2*i  ]-am_dclevel1;     
        zo[4*i+1]=0;     
        zo[4*i+2]=z[2*i+1];     
        zo[4*i+3]=0;     
        }
      }  
    else
      {
      for(i=0; i<sizhalf; i++)
        {
        zo[4*i  ]=z[2*i  ];     
        zo[4*i+1]=0;     
        zo[4*i+2]=z[2*i+1];     
        zo[4*i+3]=0;     
        }
      }
    break;
       
    case 3:
// Use the carrier phase to make I/Q demodulator.
// We already did it in the coherent function so just use the data.
// Send I to both ears, but only if greater than zero. Skip Q.
    zo=&baseb_out[2*baseb_pa];        
    for(i=0; i<sizhalf; i++)
      {
      if(z[2*i] > 0)
        {
        zo[2*i]=z[2*i];
        }     
      else 
        {
        zo[2*i]=0;
        }     
      zo[2*i+1]=0;     
      }
    break;
       
    default:
    lirerr(82615);
    }
  }  
baseb_pa=(baseb_pa+sizhalf)&baseband_mask;
// baseb_threshold is inaccurate since the backwards fast attack
// slow release peak detector can not have the decay corresponding
// to what will happen after baseb_pa.
// Set baseb_pb to point at a distance where the next key down
// has decayed backwards. 
baseb_pb=(baseb_pa-(int)(20*cg_code_unit)+baseband_size)&baseband_mask;
baseb_wts+=sizhalf;
fft3_px=(fft3_px+fft3_block)&fft3_mask;
}
