
#define SPECIFIC_DEVICE_CODES 9999
#define SDR14_DEVICE_CODE (SPECIFIC_DEVICE_CODES+1)
#define SDRIQ_DEVICE_CODE (SPECIFIC_DEVICE_CODES+2)

#define SDR14_SAMPLING_CLOCK 66.6666666

// Structure for SDR-14 parameters
typedef struct {
int m_cic2;
int m_cic5;
int m_rcf;
int ol_rcf;
int att;
int input;
int check;
}P_SDR14;
#define MAX_SDR14_PARM 7



extern char *sdr14_parm_text[MAX_SDR14_PARM];

extern P_SDR14 sdr14;
extern char *sdr14_name_string;
extern char *sdriq_name_string;
extern int sdr;
extern int sdr14_freq;

void lir_sdr14_write(void *s, int bytes);
int lir_sdr14_read(void *s, int bytes);
void sdr_target_name(char *s);
void sdr_target_serial_number(char *s);
void sdr_target_interface_version(char *s);
void sdr_target_boot_version(char *s);
void sdr_target_firmware_version(char *s);
void sdr_set_nco(void);
void set_sdr14_att(void);
void open_sdr14(int write_log);
void close_sdr14(void);
void sdr14_stop(void);
void init_sdr14(void);
