

#define MAX_DISPLAY_TYPES 3
#define MAX_SSBPROC_FILES 15
#define MAX_CWPROC_FILES 10
#define SSB_MINFQ_LOW 50
#define SSB_MINFQ_HIGH 3000
#define SSB_MAXFQ_LOW 1000
#define SSB_MAXFQ_HIGH 8000
#define SSB_MINSLOPE -50
#define SSB_MAXSLOPE 50
#define SSB_MINBASS -50
#define SSB_MAXBASS 50
#define SSB_MINTREBLE -50
#define SSB_MAXTREBLE 50
#define SSB_MAX_MICF 120
#define SSB_MAX_MICT 120
#define SSB_MAX_MICGAIN 120
#define SSB_MAX_MICAGC_TIME 1000
#define SSB_MAX_MICOUT_GAIN 80
#define SSB_MIN_RF1_GAIN -50
#define SSB_MAX_RF1_GAIN 120
#define MAX_DYNRANGE 0.0000001 // -70dB for weakest signal
#define TX_WRBLOCK_MAXCNT 100
#define TX_AGC_THRESHOLD 1.

#define TX_SETUP_AD 0
#define TX_SETUP_MUTE 1
#define TX_SETUP_MICAGC 2
#define TX_SETUP_RF1AGC 3
#define TX_SETUP_RF1CLIP 4

#define TX_BAR_AD_LINE 9
#define TX_BAR_MUTE_LINE 11
#define TX_BAR_MICAGC_LINE 13
#define TX_BAR_RF1AGC_LINE 15
#define TX_BAR_RF1CLIP_LINE 17
#define TX_BAR_ALC_LINE 19
#define TXPAR_INPUT_LINE 21

#define MIC_KEY_LINE 12
#define KEY_INDICATOR_LINE (MIC_KEY_LINE+10)
#define TXCW_INPUT_LINE (KEY_INDICATOR_LINE+4)
#define CW_MAX_TIME_CONSTANT 100.0
#define CW_MIN_TIME_CONSTANT 1.0

#define TX_BAR_SIZE 256

#define MAX_DISPLAY_TYPES 3
#define DISPLAY_HOLD_SIZE 32
#define TG_HSIZ (FG_HSIZ+4*text_width)
#define TG_VSIZ (FG_VSIZ+text_height)

#define MAX_SCREENCOUNT 16

extern double tg_basebfreq;
extern int mic_key_pa;
extern int mic_key_px;
extern int screen_count;
extern int tx_lowest_bin;
extern int tx_highest_bin;
extern char *clipfft_mute;
extern char *cliptimf_mute;
extern char *alctimf_mute;
extern float *tx_mic_key;
extern float micfft_winfac;
extern int tg_old_y1;
extern int tg_old_y2;
extern int tg_old_x1;
extern int tg_old_x2;
extern float tx_ssbproc_fqshift;
extern int mic_key_bufsiz;
extern int mic_key_block;
extern int mic_key_mask;
extern int tx_indicator_first_pixel;

extern int tx_graph_scro;
extern int tx_flag;
extern int tx_read_bytes;
extern int txmem_size;
extern int tx_ad_maxamp;
extern int tx_input_mode;
extern int tx_input_fragsize;
extern int tx_output_fragsize;
extern int tx_output_totsamp;
extern int tx_write_bytes;
extern float tx_resamp_ampfac1;
extern float tx_resamp_ampfac2;
extern int *txmem_handle;
extern int tx_audio_in;
extern int tx_audio_out;
extern short int *txtrace;
extern float txad_hz_per_bin;
extern float txtrace_gain;
extern int txtrace_height;
extern float micfft_bin_minpower_ref;
extern float micfft_bin_minpower;
extern float micfft_minpower_ref;
extern float micfft_minpower;
extern float *mic_filter;
extern int *tx_out_int;

extern short int *tx_out_shi;
extern float tx_agc_factor;
extern float tx_agc_decay;
extern float txpwr_decay;
extern float tx_forwardpwr;
extern float tx_backpwr;
extern int tx_output_flag;
extern int tx_ph1;
extern float tx_resample_ratio;
extern float new_tx_resample_ratio;
extern int tx_output_upsample;
extern int tx_resamp_pa;
extern int tx_resamp_px;
extern int tx_filter_ia1;
extern int tx_filter_ia2;
extern int tx_filter_ia3;
extern int tx_filter_ib1;
extern int tx_filter_ib2;
extern int tx_filter_ib3;
extern char display_color[MAX_DISPLAY_TYPES];
extern int tx_pre_resample;
extern int tx_wrblock_no;
extern int tx_output_mode;
extern int tx_show_siz;
extern int tx_wsamps;
extern float tx_wttim;
extern float tx_wttim_sum;
extern float tx_wttim_ref;
extern float tx_wttim_diff;
extern double tx_output_phase;
extern float tx_output_phstep;
extern int tx_setup_flag;

extern char ssbproc_filename[];
extern char cwproc_filename[];
extern char *txproc_filename;


// ***************************************************
//      Transform sizes and associated variables.
//
// ***************************************************
// The first time function, data from the soundcard. The transform
// size is set for the data to span a suitable time in order to
// get a frequency resolution and an associated time delay that
// is independent of the microphone input sampling speed.
// Size is micsize.
extern short int *mictimf_shi;
extern int *mictimf_int;
extern int micsize;
extern int micn;
extern int mictimf_pa;
extern int mictimf_px;
extern int mictimf_block;
extern int mictimf_bufsiz;
extern int mictimf_mask;
extern float *mic_win;
extern COSIN_TABLE *mic_table;
extern unsigned short int *mic_permute;
extern float *mic_tmp;
// ***************************************************
// The first FFT. The transforms are likely to span a far too large
// frequency range. Only the minimum required to represent the passband
// of interest is used for the output of mic_fft     
// Size is mic_fftsize.
extern float *micfft;
extern int mic_fftsize; 
extern int mic_fftn;
extern int mic_fftsize_start;
extern int mic_fftn_start;
extern int mic_sizhalf;
extern int micfft_pa;
extern int micfft_px;
extern int micfft_block;
extern int micfft_bufsiz;
extern int micfft_mask;
extern COSIN_TABLE *micfft_table;
extern unsigned short int *micfft_permute;
extern float *micfft_win;
extern int micfft_indicator_block;
// ***************************************************
// The second time function. Here we will do clipping.
// Size is mic_fftsize.
extern float *cliptimf;
extern int cliptimf_pa;
extern int cliptimf_px;
// ***************************************************
// The second FFT. Used to clean up the spectrum.
// Size is alc_fftsize.
extern float *clipfft;
extern int clipfft_pa;
extern int clipfft_px;
// ***************************************************
// The third time function. Used for ALC.
// We will use this time function for resampling to a new sampling speed
// that will be equal to the output speed or a power of two faster or
// slower.
// The fractional resampler needs an oversampled input and therefore
// we first upsample by a power of two here.
// Size is alc_fftsize.
extern int alc_fftsize;
extern int alc_fftn;
extern int alc_sizhalf;
extern float *alctimf;
extern float *alctimf_pwrf;
extern float *alctimf_pwrd;
extern int alctimf_pa;
extern int alctimf_pb;
extern float alctimf_fx;
extern int alc_block;
extern int alc_bufsiz;
extern int alc_mask;
extern COSIN_TABLE *alc_table;
extern unsigned short int *alc_permute;
extern float *alc_win;
// ***************************************************
// The fourth time function, the output from the fractional resampler.
// Size is alc_fftsize.
// We use transforms one by one so no buffer pointer is needed.
// The third FFT is computed in place and the size of the transform
// is changed in place to txout_fftsize.
extern float *tx_resamp;
extern float *resamp_tmp;
// ***************************************************
// The fifth time function. 
// Size is txout_fftsize.
extern int txout_fftsize;
extern int txout_fftn;
extern int txout_sizhalf;
extern float *txout;
extern float *txout_tmp;
extern COSIN_TABLE *txout_table;
extern unsigned short int *txout_permute;
// ****************************************************

void show_txfft(float *z, float lim, int type, int siz);
void tx_bar(int xt,int yt,int val1, int val2);
void resample_tx_output(void);
void check_txparms(void);
void init_txmem_spproc(void);
void init_txmem_cwproc(void);
void open_tx_input(void);
void close_tx_input(void);
void spproc_setup(void);
void cwproc_setup(void);
void save_tx_parms(char verbose);
int lir_tx_input_samples(void);
int lir_tx_output_samples(void);
void open_tx_output(void);
void close_tx_output(void);

void make_tx_graph(int clear_old);
void init_txmem_cwproc(void);
void make_txproc_filename(void);
void tx_ssb_step8(void);
float tx_ssb_step7(float *prat);
float tx_ssb_step6(float *prat);
void tx_ssb_step5(void);
void tx_ssb_step4(float ampinv,float *t1, float *prat);
void tx_ssb_step3(float *totamp);
int tx_ssb_step2(float *totpwr);
void set_default_cwproc_parms(void);
void make_tx_modes(void);
void tx_send_to_da(void);
void make_tx_cw_waveform(void);
void make_tx_phstep(void);


