
#include <stdio.h>
#include <unistd.h>
#include <unistd.h>
#include <string.h>
#include "globdef.h"
#include "uidef.h"
#include "fft1def.h"
#include "fft2def.h"
#include "fft3def.h"
#include "screendef.h"
#include "seldef.h"
#include "sigdef.h"
#include "hwaredef.h"
#include "thrdef.h"
#include "conf.h"
#include "rusage.h"
#include "options.h"
#include "blnkdef.h"

#define MOUSE_MIN_TIME 0.05

void rx_output(void)
{
int local_output_channels;
int dasync_time_interval;
int local_restart_counter;
int local_output_bytes;
int dasync_errors;
int backpost_count;
char s[80];
double dt1;
int i, local_workload_reset;
int speed_cnt;
float t1, t2;
double total_time2;
#if (RUSAGE_OLD == 1)
int wlcnt_max=4*rx_output_blockrate;
int wlcnt, local_reset;
float t3;
double total_time1;
double cpu_time1;
double cpu_time2;
total_time1=current_time();
cpu_time1=lir_get_cpu_time();
wlcnt=wlcnt_max;
local_reset=workload_reset_flag;
#endif
dasync_errors=0;
backpost_count=0;
dasync_time_interval=7*fft3_size/timf3_sampling_speed;
if(dasync_time_interval < 7*fft1_size/timf1_sampling_speed)
                       dasync_time_interval = 7*fft1_size/timf1_sampling_speed;
if(genparm[SECOND_FFT_ENABLE]!=0)
  {
  if(dasync_time_interval < 7*fft2_size/timf1_sampling_speed)
                      dasync_time_interval = 7*fft2_size/timf1_sampling_speed;
  }
if(dasync_time_interval < 0.5)dasync_time_interval=0.5;
local_output_channels=rx_daout_channels;
local_output_bytes=rx_daout_bytes;
daout_px=0;
local_restart_counter=daout_restart_counter;
local_workload_reset=workload_reset_flag;
rx_da_maxbytes=0;
thread_status_flag[THREAD_RX_OUTPUT]=THRFLAG_ACTIVE;
speed_cnt=rx_output_blockrate;
while(thread_command_flag[THREAD_RX_OUTPUT] == THRFLAG_ACTIVE)
  {
#if (RUSAGE_OLD==1)
  wlcnt--;
  if(wlcnt==0)
    {
    wlcnt=wlcnt_max;
    total_time2=current_time();
    cpu_time2=lir_get_cpu_time();
    t3=100/(total_time2-total_time1);
    t1=(cpu_time2-cpu_time1)*t3;
    if(t1<0)t1=0;
    workloads[THREAD_RX_OUTPUT]=t1;
    if(local_reset != workload_reset_flag)
      {
      local_reset=workload_reset_flag;
      total_time1=total_time2;
      cpu_time1=cpu_time2;
      }
    }
#endif
  speed_cnt--;
  if(speed_cnt==0)
    {
    if(local_workload_reset!=workload_reset_flag)
      {
      rx_da_maxbytes=0;
      local_workload_reset=workload_reset_flag;
      }
    speed_cnt=rx_output_blockrate;
    total_time2=current_time();
    if(total_time2-daspeed_time > 0)
      {
// Compute the D/A speed once every second.
      daspeed_time+=1;
      i=lir_rx_output_bytes();
      if(kill_all_flag) goto da_output_error;
      if(da_start_samps == -1)
        {
        da_start_time=total_time2; 
        da_block_counter=0;
        da_start_samps=i;
        rx_da_maxbytes=0;
        }
      else
        {
        measured_da_speed=(da_block_counter*rx_daout_block+i-da_start_samps)/
                                (local_output_channels*local_output_bytes*
                                                (total_time2-da_start_time));
        }
      }  
// Keep track of the error in the frequency ratio between input and output.
// Average the total processing delay and adjust resampling rate to 
// keep it constant. 
#define DASYNC_MAXCOUNT 15 //Number used to form average
    dt1=current_time();
    if(  disksave_flag != 2 && 
         new_baseb_flag == 0 &&
         dt1-dasync_avgtime > dasync_time_interval )
      {
      dasync_avgtime=dt1;
      make_timing_info();
      if(kill_all_flag) goto da_output_error;
      if(timinfo_flag != 0)
        {
        sprintf(s,"sync:%f ",total_wttim-dasync_avg3);
        lir_text(26,screen_last_line-7,s);
        }
      if(dasync_avg3 >= 0 && fabs(total_wttim-dasync_avg3)>0.5)
        {
        dasync_errors++;
        sprintf(s,"DA SYNC ERRORS %d",dasync_errors);
        wg_error(s,1);
        if(new_baseb_flag >= 0)
          {
          clear_da();
          if(kill_all_flag) goto da_output_error;
          }
        goto syncx;
        }
      dasync_counter++;
      dasync_sum+=total_wttim;
      if(dasync_counter >= DASYNC_MAXCOUNT)
        {
        dasync_avg1=dasync_sum/dasync_counter;
        dasync_counter=0;
        dasync_sum=0;
        t2=dt1-dasync_time;
        dasync_time=dt1;
        if(dasync_avg2 > 0)
          {
// The drift between input and output after t2 seconds is
// the difference between the two averages.
// Convert to frequency ratio, but use half the error only 
// to avoid oscillations.
// Correct for the deviation from the first average, but only 20%
// so we drift slowy towards it if we are off.
          t1= (t2+0.5*(dasync_avg2-dasync_avg1)+
                                   0.2*(dasync_avg3-dasync_avg1))/t2;
          new_da_resample_ratio=da_resample_ratio*t1;
          dasync_avg2=dasync_avg1;
          }
        else
          {
          if(dasync_avg3 <0) 
            {
            dasync_avg3=dasync_avg1;
            }
          else
            {
            dasync_avg2=dasync_avg1;
            }
          }
        }
      }
syncx:;     
    }
  thread_status_flag[THREAD_RX_OUTPUT]=THRFLAG_SEM_WAIT;
  lir_sem_wait(SEM_RX_DASIG);
  if(thread_command_flag[THREAD_RX_OUTPUT]!=THRFLAG_ACTIVE)goto daend;
  thread_status_flag[THREAD_RX_OUTPUT]=THRFLAG_ACTIVE;
#if BUFBARS == TRUE
  if(timinfo_flag!=0)
    {
    i=(daout_px-daout_pa+daout_bufmask+1)&daout_bufmask;
    i/=daout_indicator_block;
    lir_hline(indicator_first_pixel,indicator_ypix-24,
                         indicator_first_pixel+INDICATOR_SIZE-i-1,15);
    lir_hline(indicator_first_pixel+INDICATOR_SIZE-i,indicator_ypix-24,
                         indicator_first_pixel+INDICATOR_SIZE-1,1);
    }    
#endif    
  if(rx_audio_out == -1)goto daend;
  if(local_restart_counter!=daout_restart_counter)
    {
    if(new_baseb_flag == 3)goto daend;
    if(new_baseb_flag == 2)
      {
      if(daout_px >= 0)
        {
        if( local_output_channels != rx_daout_channels ||
                          local_output_bytes != rx_daout_bytes)
          {
          local_output_channels=rx_daout_channels;
          local_output_bytes=rx_daout_bytes;
          close_rx_sndout();
          open_rx_sndout();
          if(kill_all_flag) goto da_output_error;
          }
        else
          {
          lir_empty_da_device_buffer();
          }
        for(i=0; i<rx_daout_block; i++)
          {
          rx_da_wrbuf[i]=0; 
          }
        daout_px=-1;  
        }
      }
    else
      {
      if(new_baseb_flag == 1)  
        {
        daout_px=daout_pa;
        }
      else
        {
        if(new_baseb_flag == 0)  
          {
          da_start_samps=-1;
          local_restart_counter=daout_restart_counter;
          dasync_counter=0;
          dasync_sum=0;
          dasync_avg1=-1.5;
          dasync_avg2=-1.5;
          dasync_avg3=-1.5;
          dasync_time=current_time();
          dasync_avgtime=dasync_time;
          daspeed_time=dasync_time+1;
          daout_px=(daout_px+rx_daout_block)&daout_bufmask;
          }
        }
      }
    i=rx_da_totbytes-make_da_wts();
    if(kill_all_flag) goto da_output_error;
    if( i < rx_daout_block && audio_dump_flag == 0)
      { 
      lir_rx_dawrite();
      if(kill_all_flag) goto da_output_error;
      }  
    goto daend;
    }
// Write data to the output device.
  for(i=0; i<rx_daout_block; i++)
    {
    rx_da_wrbuf[i]=daout[daout_px]; 
    daout_px=(daout_px+1)&daout_bufmask;
    }
  if(audio_dump_flag == 0)
    {
    lir_rx_dawrite();
    }
  if(wav_write_flag != 0)
    {
    if(fwrite(rx_da_wrbuf,rx_daout_block,1,wav_file)!=1)wavsave_start_stop(0);
    if(kill_all_flag) goto da_output_error;
    wavfile_bytes+=rx_daout_block;
    }
  da_block_counter+=1;
daend:;
  }
da_output_error:; 
if(rx_audio_out != -1)close_rx_sndout();
thread_status_flag[THREAD_RX_OUTPUT]=THRFLAG_RETURNED;
while(thread_command_flag[THREAD_RX_OUTPUT] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}

void wideband_dsp(void)
{
int local_spurcancel_flag;
int local_spurinit_flag;
int i, k;
int local_ampinfo_reset;
int local_timf1p_pa;
int postp_pa, max_postbytes;
double mouse_time;
#if (RUSAGE_OLD == 1)
int wlcnt_max=3*fft1_rate;
int wlcnt, local_reset;
float t1, t3;
double total_time1;
double total_time2;
double cpu_time1;
double cpu_time2;
total_time1=current_time();
cpu_time1=lir_get_cpu_time();
wlcnt=wlcnt_max;
local_reset=workload_reset_flag;
#endif
local_ampinfo_reset=workload_reset_flag;
local_timf1p_pa=ad_read_bytes;
local_spurcancel_flag=spurcancel_flag;
local_spurinit_flag=spurinit_flag;
postp_pa=timf1p_pa;
max_postbytes=0.1*interrupt_rate*ad_read_bytes;
// ****************************************************************
// Initialise variables for fft1/fft2 here.
// Linrad 01.xx did everything in buf.c so this place is used only
// for new or changed things
// ****************************************************************
fft1_sumsq_pwsref=fft1_sumsq_pws;
// *****************************************************************
if(thread_command_flag[THREAD_SCREEN]!=THRFLAG_NOT_ACTIVE)
  {
  while(thread_status_flag[THREAD_SCREEN]!=THRFLAG_ACTIVE &&
        thread_status_flag[THREAD_SCREEN]!=THRFLAG_IDLE &&
        thread_status_flag[THREAD_SCREEN]!=THRFLAG_SEM_WAIT)
    {
    if(thread_command_flag[THREAD_WIDEBAND_DSP] == 
                                           THRFLAG_KILL)goto wide_error_exit;
    lir_sleep(10000);
    }
  }  
restart:;
mouse_time=current_time();
thread_status_flag[THREAD_WIDEBAND_DSP]=THRFLAG_ACTIVE;
while(thread_command_flag[THREAD_WIDEBAND_DSP] == THRFLAG_ACTIVE)
  {
  if(ampinfo_flag != 0)
    {
    if(local_ampinfo_reset!=workload_reset_flag)
      {
      local_ampinfo_reset=workload_reset_flag;
      clear_wide_maxamps();
      }
    }
#if (RUSAGE_OLD==1)
  wlcnt--;
  if(wlcnt==0)
    {
    wlcnt=wlcnt_max;
    total_time2=current_time();
    cpu_time2=lir_get_cpu_time();
    t3=100/(total_time2-total_time1);
    t1=(cpu_time2-cpu_time1)*t3;
    if(t1<0)t1=0;
    workloads[THREAD_WIDEBAND_DSP]=t1;
    if(local_reset != workload_reset_flag)
      {
      local_reset=workload_reset_flag;
      total_time1=total_time2;
      cpu_time1=cpu_time2;
      }
    }
#endif
wait:;
  if(genparm[AFC_ENABLE] == 2)
    {
    if(wg.spur_inhibit == 0)
      {
      i=no_of_spurs;
      if(genparm[SECOND_FFT_ENABLE] != 0)
        {
        fftx_na=fft2_na;
        fftx_nc=fft2_nc;
        fftx_nm=fft2_nm;
        fftx_nx=fft2_nx;
        }
      else
        {
        fftx_na=fft1_nb;
        fftx_nc=fft1_nc;
        fftx_nm=fft1_nm;
        fftx_nx=fft1_nx;
        }
      k=0;
      while(k<512 && autospur_point < spur_search_last_point && no_of_spurs-i < 16)
        {
        init_spur_elimination();
        k++;
        }
      }  
    }
  if(local_spurinit_flag != spurinit_flag)
    {
    local_spurinit_flag=spurinit_flag;
    if(genparm[SECOND_FFT_ENABLE] != 0)
      {
      fftx_na=fft2_na;
      fftx_nc=fft2_nc;
      fftx_nm=fft2_nm;
      fftx_nx=fft2_nx;
      }
    else
      {
      fftx_na=fft1_nb;
      fftx_nc=fft1_nc;
      fftx_nm=fft1_nm;
      fftx_nx=fft1_nx;
      }
    init_spur_elimination();
    }
  if(local_spurcancel_flag != spurcancel_flag)
    {
    local_spurcancel_flag=spurcancel_flag;
    no_of_spurs=0;
    }      
  lir_sem_wait(SEM_TIMF1);
  if(thread_command_flag[THREAD_WIDEBAND_DSP] != THRFLAG_ACTIVE)goto wideend;
// Here we do the mouse actions that affect the wide graph.
// Currently only the waterfall memory area may become re-allocated
  if(recent_time-mouse_time > MOUSE_MIN_TIME)
    {
    mouse_time=current_time();
    if(mouse_task!=-1)
     {
      k=mouse_task&GRAPH_MASK;
      if( k < MAX_WIDEBAND_GRAPHS)
        {
        set_button_states();
        if(mouse_active_flag == 0)
          {
          switch (k)
            {
            case WIDE_GRAPH:
            if( (mouse_task&GRAPH_RIGHTPRESSED) != 0)
              {
              wide_graph_add_signal();
              if(rightpressed==BUTTON_IDLE)mouse_task=-1;
              goto mouse_x;
              }
            else
              {
              mouse_on_wide_graph();
              }
            break;

            case HIRES_GRAPH:
            mouse_on_hires_graph();
            break;
            }  
          if(mouse_active_flag == 0)lirerr(28877);
          }
        if(numinput_flag==0)
          {
          current_mouse_activity();
          if(kill_all_flag)return;
          }  
        if( (numinput_flag&DATA_READY_PARM) != 0)
          {
          par_from_keyboard_routine();
          if(kill_all_flag)return;
          par_from_keyboard_routine=NULL;
          mouse_active_flag=0;
          numinput_flag=0;
          leftpressed=BUTTON_IDLE;  
          }
        if(mouse_active_flag == 0)
          {
          mouse_task=-1;
          }
mouse_x:;
        }
      }
    }
  if(kill_all_flag) goto wide_error_exit;
  if( (ui.network_flag & NET_RXIN_FFT1) == 0)
    {
#if BUFBARS == TRUE
    if(timinfo_flag!=0)
      {
      k=ad_read_bytes;
      if(ui.rx_addev_no >= 256)k<<=1;
      i=(local_timf1p_pa-timf1p_pa-k+timf1_bytes)&timf1_bytemask;
      i/=timf1_indicator_block;
      lir_hline(indicator_first_pixel,indicator_ypix,
                                indicator_first_pixel+INDICATOR_SIZE-i-1,15);
      if(kill_all_flag) return;
      lir_hline(indicator_first_pixel+INDICATOR_SIZE-i,indicator_ypix,
                                   indicator_first_pixel+INDICATOR_SIZE-1,1);
      if(kill_all_flag) return;
      }
#endif    
    if( ((timf1p_pa-local_timf1p_pa+timf1_bytes)&
                                       timf1_bytemask) < timf1_blockbytes)
      {
gowait:;
      if( ((timf1p_pa-postp_pa+timf1_bytes)&
                                       timf1_bytemask) > max_postbytes)
        {
        postp_pa=timf1p_pa;
        lir_sem_post(SEM_FFT1);
        }    
      goto wait;
      }
    if( fft1_px == ((fft1_pa+fft1_block)&fft1_mask) )
      {
      goto gowait;
      }
    local_timf1p_pa=(local_timf1p_pa+timf1_blockbytes)&timf1_bytemask;
    fft1_b();
    }
  fft1_c();
#if BUFBARS == TRUE
  if(timinfo_flag!=0)
    {
    k=(fft1_px-fft1_pa-fft1_block+fft1_mask+1)&fft1_mask;
    k/=fft1_indicator_block;
    lir_hline(indicator_first_pixel,indicator_ypix-3,
                         indicator_first_pixel+INDICATOR_SIZE-k-1,15);
    lir_hline(indicator_first_pixel+INDICATOR_SIZE-k,indicator_ypix-3,
                         indicator_first_pixel+INDICATOR_SIZE-1,1);
    }
#endif    
  if(fft1_waterfall_flag)
    {  
    while(fft1_sumsq_pws != fft1_sumsq_pa ) 
      {
      update_fft1_slowsum();
      }
    }  
  if( genparm[SECOND_FFT_ENABLE] == 0 ) 
    {
    if(fft1_waterfall_flag)fft1_waterfall();

    lir_sem_post(SEM_FFT1);
    postp_pa=timf1p_pa;
    }
  else
    {
    if(fft1_size > 16384)lir_sched_yield();
    make_timf2();
#if BUFBARS == TRUE
    if(timinfo_flag!=0)
      {
      k=(timf2_px-timf2_pa-fft1_block+timf2_mask+1)&timf2_mask;
      k/=timf2_indicator_block;
      lir_hline(indicator_first_pixel,indicator_ypix-6,
                           indicator_first_pixel+INDICATOR_SIZE-k-1,15);
      lir_hline(indicator_first_pixel+INDICATOR_SIZE-k,indicator_ypix-6,
                           indicator_first_pixel+INDICATOR_SIZE-k,1);
      }
#endif  
    first_noise_blanker();
// Add the two parts of timf2 so we get a single time function
// and produce the second fft.
// Note that the fft2 routine still is split into a number of small
// chunks so we have to call until the flag is set.
    if(fft1_size > 8192)lir_sched_yield();
    while( ((timf2_pn2-timf2_px+timf2_totbytes)&timf2_mask) >=
                                              4*ui.rx_rf_channels*fft2_size )
      {
      make_fft2_status=FFT2_NOT_ACTIVE;
      while(make_fft2_status != FFT2_COMPLETE)
        {
        make_fft2();
        if(fft2_size > 32768)lir_sched_yield();
        fft1_nx=fft1_px/fft1_block;
        }
      lir_sem_post(SEM_FFT1);
      postp_pa=timf1p_pa;
      }
#if BUFBARS == TRUE
    if(timinfo_flag!=0)
      {
      k=(fft2_nx-fft2_na+fft2n_mask)&fft2n_mask;
      k*=fft2_size;
      k/=fft2n_indicator_block;
      lir_hline(indicator_first_pixel,indicator_ypix-9,
                           indicator_first_pixel+INDICATOR_SIZE-k-1,15);
      lir_hline(indicator_first_pixel+INDICATOR_SIZE-k,indicator_ypix-9,
                           indicator_first_pixel+INDICATOR_SIZE-1,1);
      }
#endif    
    }
wideend:;
  }
if(thread_command_flag[THREAD_WIDEBAND_DSP]==THRFLAG_IDLE)
  {
// The wideband dsp thread is running and it puts out
// the waterfall graph. 
// We stop it now on order from the tx_test thread.
  thread_status_flag[THREAD_WIDEBAND_DSP]=THRFLAG_IDLE;
  while(thread_command_flag[THREAD_WIDEBAND_DSP]==THRFLAG_IDLE)
    {
    lir_sem_wait(SEM_TIMF1);
    timf1p_px=(timf1p_px+timf1_blockbytes)&timf1_bytemask;
    }
  if(thread_command_flag[THREAD_WIDEBAND_DSP] == THRFLAG_ACTIVE)goto restart;
  }
wide_error_exit:;  
thread_status_flag[THREAD_WIDEBAND_DSP]=THRFLAG_RETURNED;
while(thread_command_flag[THREAD_WIDEBAND_DSP] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}


void narrowband_dsp(void)
{
char s[80];
int i, k, dl, baseb_output_block;
int local_fftx_na;
int syncflag;
int idle_flag, mix1_flag;
double dt1, disksync_time, mouse_time;
double total_time1;
float t1, t3;
#if (RUSAGE_OLD == 1)
int wlcnt_max=fft1_rate;
int wlcnt, local_reset;
double total_time2;
double cpu_time1;
double cpu_time2;
cpu_time1=lir_get_cpu_time();
wlcnt=wlcnt_max;
local_reset=workload_reset_flag;
#endif
daout_start_px=-1;
new_baseb_flag=-1;
total_time1=current_time();
dt1=total_time1;  
disksync_time=total_time1;
mouse_time=total_time1;
idle_flag=0;
s[0]=0;
syncflag=0;
baseb_output_block=128;
if(genparm[SECOND_FFT_ENABLE] == 0)
  {
  local_fftx_na=fft1_nb;
  }
else
  {
  local_fftx_na=fft2_na;
  }
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// *******************************************************
//                   MAIN RECEIVE LOOP
// *******************************************************
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
while(thread_status_flag[THREAD_SCREEN]!=THRFLAG_ACTIVE &&
      thread_status_flag[THREAD_SCREEN]!=THRFLAG_IDLE &&
      thread_status_flag[THREAD_SCREEN]!=THRFLAG_SEM_WAIT)
 {
 if(thread_command_flag[THREAD_NARROWBAND_DSP] == 
                                           THRFLAG_KILL)goto wcw_error_exit;
 lir_sleep(10000);
 }
resume:;
mix1_flag=0;
thread_status_flag[THREAD_NARROWBAND_DSP]=THRFLAG_ACTIVE;
while(thread_command_flag[THREAD_NARROWBAND_DSP] == THRFLAG_ACTIVE)
  {
#if (RUSAGE_OLD==1)
  wlcnt--;
  if(wlcnt==0)
    {
    wlcnt=wlcnt_max;
    total_time2=current_time();
    cpu_time2=lir_get_cpu_time();
    t3=100/(total_time2-total_time1);
    t1=(cpu_time2-cpu_time1)*t3;
    if(t1<0)t1=0;
    workloads[THREAD_NARROWBAND_DSP]=t1;
    if(local_reset != workload_reset_flag)
      {
      local_reset=workload_reset_flag;
      total_time1=total_time2;
      cpu_time1=cpu_time2;
      }
    }
#endif
  dt1=current_time();
  if(disksave_flag == 1)
    {
    if(fabs(disksync_time-dt1) > 0.2)
      {
      lir_sync();
      dt1=current_time();
      disksync_time = dt1;
      }
    }
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
// mix1_flag signals to us that there is work to do on previous
// transforms so do not wait for a new fft1/fft2 if it is nonzero.
  if(mix1_flag == 0)
    {
    idle_flag++;
    switch (idle_flag)
      {
      case 1:
      if(eme_active_flag != 0)
        {
        if(dt1 - eme_time > 3)
          {
          sc[SC_COMPUTE_EME_DATA]++;
          eme_time=dt1;
          }
        }
      break;
     
      case 2:
      if(fft1_handle != NULL)
        {
        memcheck(198,fft1mem,(int*)&fft1_handle);
        if(kill_all_flag) goto wcw_error_exit;
        }
      if(baseband_handle != NULL)
        {
        memcheck(298,basebmem,(int*)&baseband_handle);
        if(kill_all_flag) goto wcw_error_exit;
        }
      break;
      
      case 3:
      if(afc_handle != NULL)
        {
        memcheck(398,afcmem,(int*)&afc_handle);
        if(kill_all_flag) goto wcw_error_exit;
        }
      if(fft3_handle != NULL)
        {
        memcheck(498,fft3mem,(int*)&fft3_handle);
        if(kill_all_flag) goto wcw_error_exit;
        }
      if(blanker_handle != NULL)
        {
        memcheck(598,blankermem,(int*)&blanker_handle);
        if(kill_all_flag) goto wcw_error_exit;
        }
      break;
      
      case 4:
      if(hires_handle != NULL)
        {
        memcheck(598,hiresmem,(int*)&hires_handle);
        if(kill_all_flag) goto wcw_error_exit;
        }
      if( allow_parport != 0)
        {
// Read now and then to make apm aware Linrad is running.
// See z_APM.txt
        lir_inb(ui.parport);
        }
      break;

      default:
      idle_flag=0;
      break;
      }
    thread_status_flag[THREAD_NARROWBAND_DSP]=THRFLAG_SEM_WAIT;
wait:;
    lir_sem_wait(SEM_FFT1);
    if(kill_all_flag) goto wcw_error_exit;
    if(thread_command_flag[THREAD_NARROWBAND_DSP]
                                             !=THRFLAG_ACTIVE)goto narend;
// Here we do the mouse actions that affect the narrowband graphs.
// Note that memory areas may become re-allocated and that no other
// threads may try to acces the narrowband arrays in the meantime.
// The screen thread is stopped by the memory allocation routines
    if(recent_time-mouse_time > MOUSE_MIN_TIME)
      {
      mouse_time=current_time();
      k=mouse_task&GRAPH_MASK;
      if( k > MAX_WIDEBAND_GRAPHS)
        {
        set_button_states();
        if( (mouse_task&GRAPH_RIGHTPRESSED) != 0)
          {
          rightpressed=BUTTON_IDLE;
          mouse_task=-1;
          goto mouse_x;
          }
        if(mouse_active_flag == 0)
          {
          switch (k)
            {
            case AFC_GRAPH:
            mouse_on_afc_graph();
            break;

            case BASEBAND_GRAPH:
            mouse_on_baseband_graph();
            break;

            case POL_GRAPH:
            mouse_on_pol_graph();
            break;

            case COH_GRAPH:
            mouse_on_coh_graph();
            break;

            case EME_GRAPH:
            mouse_on_eme_graph();
            break;

            case FREQ_GRAPH:
            mouse_on_freq_graph();
            break;

            case METER_GRAPH:
            mouse_on_meter_graph();
            break;

            case TRANSMIT_GRAPH:
            mouse_on_tx_graph();
            break;

            default:
            mouse_on_users_graph();
            break;
            } 
          if(mouse_active_flag == 0)lirerr(8877);
          }
        if(numinput_flag==0)
          {
          current_mouse_activity();
          if(kill_all_flag) goto wcw_error_exit;
          }
        if( (numinput_flag&DATA_READY_PARM) != 0)
          {
          par_from_keyboard_routine();
          if(kill_all_flag) goto wcw_error_exit;
          par_from_keyboard_routine=NULL;
          mouse_active_flag=0;
          numinput_flag=0;
          leftpressed=BUTTON_IDLE;  
          }
        if(mouse_active_flag == 0)
          {
          mouse_task=-1;
          }
mouse_x:;        
        }
      }
    if(genparm[SECOND_FFT_ENABLE] == 0)
      {
      if(local_fftx_na == fft1_nb)goto wait;
      local_fftx_na=fft1_nb;
      }
    else
      {
      if(local_fftx_na == fft2_na)goto wait;
      local_fftx_na=fft2_na;
      }
    thread_status_flag[THREAD_NARROWBAND_DSP]=THRFLAG_ACTIVE;
    }
  else
    {
    lir_sched_yield();
    }
  mix1_flag=0;
  if(new_baseb_flag ==3)
    {
    new_baseb_flag=2;
    clear_coherent();
    daout_restart_counter++;
    if(rx_audio_out == -1)open_rx_sndout();
    lir_sched_yield();
    lir_sem_post(SEM_RX_DASIG);
    goto narend;
    }
start_output:;
  if( genparm[SECOND_FFT_ENABLE] == 0 )
    {
    if(new_baseb_flag >= 0)
      {
      if(genparm[AFC_ENABLE] != 0 && 
         (rx_mode < MODE_SSB || rx_mode == MODE_AM) )
        {
        while( fft1_nb != fft1_nc && mix1_flag==0) 
          {
          if(thread_command_flag[THREAD_NARROWBAND_DSP] != 
                                                 THRFLAG_ACTIVE)goto narend;
          make_afc();
          if(kill_all_flag) goto wcw_error_exit;
          if( fft1_nm >= afc_tpts)
            {
            while( ((fft1_nc-fft1_nx+max_fft1n)&fft1n_mask) >
                                               afct_delay_points /* &&
           ((timf3_px-timf3_pa+timf3_mask)&timf3_mask) >= timf3_block */) 
               {
               fft1_mix1_afc();
               lir_sched_yield();
               if(thread_command_flag[THREAD_NARROWBAND_DSP] != 
                                                  THRFLAG_ACTIVE)goto narend;
               }
            }
          if( ((fft1_nc-fft1_nx+max_fft1n)&fft1n_mask) > 
                                          afct_delay_points) mix1_flag|=1;
          }
        if( ag.mode_control != 0 && afc_graph_filled != 0)sc[SC_SHOW_AFC]++;
        }
      else
        {
        while( fft1_nb != fft1_nx &&
                ((timf3_px-timf3_pa+timf3_mask)&timf3_mask) >= timf3_block)
          {
          fft1_mix1_fixed();
          lir_sched_yield();
          if(thread_command_flag[THREAD_NARROWBAND_DSP] != 
                                                   THRFLAG_ACTIVE)goto narend;
          }
        if( fft1_nb != fft1_nx) mix1_flag|=1;
        }
      }
    else
      {
      fft1_nx=fft1_nb;
      fft1_px=fft1_pb;
      fft1_nb=fft1_nb;
      fft1_pb=fft1_pb;
      fft1_nc=fft1_nb;
if(genparm[SECOND_FFT_ENABLE] == 0) //öö ??
  {
  local_fftx_na=fft1_nb;
  }
else
  {
  local_fftx_na=fft2_na;
  }

      timf3_px=timf3_pa;
      fft3_px=fft3_pa;
      goto clear_baseb;
      }
    }
  else
    {
    if(new_baseb_flag >= 0)
      {
      if(genparm[AFC_ENABLE] != 0 && 
         (rx_mode < MODE_SSB || rx_mode == MODE_AM) )
        {
        while( fft2_na != fft2_nc && mix1_flag==0)
          {
          if(thread_command_flag[THREAD_NARROWBAND_DSP] != 
                                                   THRFLAG_ACTIVE)goto narend;
          make_afc();
          if(kill_all_flag) goto wcw_error_exit;
          while( ((fft2_nc-fft2_nx+max_fft2n)&fft2n_mask) >
                                                 afct_delay_points &&
             ((timf3_px-timf3_pa+timf3_mask)&timf3_mask) >= timf3_block)                                         
            {
            if(thread_command_flag[THREAD_NARROWBAND_DSP] != 
                                                  THRFLAG_ACTIVE)goto narend;
            fft2_mix1_afc();
            }
          if( ((fft2_nc-fft2_nx+max_fft2n)&fft2n_mask) > 
                                              afct_delay_points) mix1_flag|=1;
          } 
        if( ag.mode_control != 0 && afc_graph_filled != 0)sc[SC_SHOW_AFC]++;
        }
      else
        {
        while(fft2_na != fft2_nx &&
                ((timf3_px-timf3_pa+timf3_mask)&timf3_mask) >= timf3_block)
          {        
          if(thread_command_flag[THREAD_NARROWBAND_DSP] != 
                                                  THRFLAG_ACTIVE)goto narend;
          fft2_mix1_fixed();
          }
        if( fft2_na != fft2_nx) mix1_flag|=1;
        }
      }  
    else
      {
      timf3_px=timf3_pa;
      fft3_px=fft3_pa;
      goto clear_baseb;
      }
    }
#if BUFBARS == TRUE
  if(timinfo_flag!=0)
    {
    i=(timf3_px-timf3_pa-timf3_block+timf3_size)&timf3_mask;
    i/=timf3_indicator_block;
    lir_hline(indicator_first_pixel,indicator_ypix-12,
                         indicator_first_pixel+INDICATOR_SIZE-i-1,15);
    lir_hline(indicator_first_pixel+INDICATOR_SIZE-i,indicator_ypix-12,
                         indicator_first_pixel+INDICATOR_SIZE-1,1);
    }
#endif    
  if( ((timf3_pa-timf3_px+timf3_size)&timf3_mask) >= 
                                             twice_rxchan*fft3_size &&
                    ((fft3_px-fft3_pa+fft3_mask)&fft3_mask) > fft3_block)
    {
    make_fft3_all();
    }
  if( ((timf3_pa-timf3_px+timf3_size)&timf3_mask) >= 
                                             twice_rxchan*fft3_size &&
                      ((fft3_px-fft3_pa+fft3_mask)&fft3_mask) > fft3_block)
    {
    mix1_flag|=1;
    }
#if BUFBARS == TRUE
  if(fft3_handle != NULL && timinfo_flag!=0)
    {
    i=(fft3_px-fft3_pa-fft3_block+fft3_totsiz)&fft3_mask;
    i/=fft3_indicator_block;
    lir_hline(indicator_first_pixel,indicator_ypix-15,
                         indicator_first_pixel+INDICATOR_SIZE-i-1,15);
    lir_hline(indicator_first_pixel+INDICATOR_SIZE-i,indicator_ypix-15,
                         indicator_first_pixel+INDICATOR_SIZE-1,1);
    }
#endif    
  if(afc2_active_flag != 0)
    {
    dl=bg.afc2_delay*fft3_block/2;
    }
  else
    {
    dl=0;
    }  
  if( ((fft3_pa-fft3_px-dl+fft3_totsiz)&fft3_mask) >= fft3_block &&
      (((int)(baseb_fx)-baseb_pa+baseband_mask)&baseband_mask) > mix2_size+16) 
    {
   
    fft3_mix2();
    if(kill_all_flag) goto wcw_error_exit;
    if(new_baseb_flag ==0)
      {
      if(genparm[CW_DECODE_ENABLE] != 0)
        {
        coherent_cw_detect();
        if(kill_all_flag) goto wcw_error_exit;
        }
      if(cg.oscill_on != 0)sc[SC_CG_REDRAW]++;
      }
    }
  if( ((fft3_pa-fft3_px-dl+fft3_totsiz)&fft3_mask) >= fft3_block &&
      (((int)(baseb_fx)-baseb_pa+baseband_mask)&baseband_mask) > mix2_size+16) 
    {
    mix1_flag|=1;
    }
#if BUFBARS == TRUE
  if(baseband_handle != NULL && timinfo_flag!=0)
    {
    i=((int)(baseb_fx)-baseb_pa-fft3_block-8+baseband_mask+1)&baseband_mask;
    i/=baseb_indicator_block;
    lir_hline(indicator_first_pixel,indicator_ypix-18,
                         indicator_first_pixel+INDICATOR_SIZE-i-1,15);
    lir_hline(indicator_first_pixel+INDICATOR_SIZE-i,indicator_ypix-18,
                         indicator_first_pixel+INDICATOR_SIZE-1,1);
    }
#endif  

  if( (ui.rx_input_mode&NO_DUPLEX) != 0 && rx_audio_out == -1)
    {
clear_baseb:;
    baseb_wts=4;
    baseb_fx=(baseb_pa-4+baseband_size)&baseband_mask;
    daout_pa=0;
    daout_pb=0;
    if(new_baseb_flag < 0)goto narend;
    }
  if( baseb_wts > baseb_output_block+baseb_margin)
    {
    if(new_baseb_flag == 0)
      {
      make_audio_signal();
      if(rx_audio_out == -1)goto narend;
      t1=(genparm[OUTPUT_DELAY_MARGIN]+0.1)*genparm[DA_OUTPUT_SPEED];
      t1-=make_da_wts();
      if(kill_all_flag) goto wcw_error_exit;
      while( ((daout_pa-daout_pb+daout_bufmask+1)&daout_bufmask) >=
                                         rx_daout_block && t1 > daout_samps)
        {
        if(thread_command_flag[THREAD_NARROWBAND_DSP] != 
                                                  THRFLAG_ACTIVE)goto narend;
        lir_sem_post(SEM_RX_DASIG);
        t1-=daout_samps;
        daout_pb=(daout_pb+rx_daout_block)&daout_bufmask;
        }
#if BUFBARS == TRUE
      if(baseband_handle != NULL && timinfo_flag!=0)
        {
        i=(daout_pb-daout_pa-8+daout_bufmask+1)&daout_bufmask;
        i/=daout_indicator_block;
        lir_hline(indicator_first_pixel,indicator_ypix-21,
                           indicator_first_pixel+INDICATOR_SIZE-i-1,15);
        lir_hline(indicator_first_pixel+INDICATOR_SIZE-i,indicator_ypix-21,
                           indicator_first_pixel+INDICATOR_SIZE-1,1);
        }    
#endif    
      goto narend; 
      }
    if(rx_audio_out == -1)goto narend;
    t1=1.5+daout_pa/(rx_daout_channels*rx_daout_bytes*da_resample_ratio);
    i=baseb_fx+t1;
    baseb_wts=((baseb_pa-i+baseband_size)&baseband_mask);
    lir_sched_yield();
    make_timing_info();
    if(kill_all_flag) goto wcw_error_exit;
    t1=total_wttim-da_wait_time;
    if(new_baseb_flag == 2)
      {
      if(t1 > 0 && daout_px==-1)
        {
        new_baseb_flag=1;
        }
      lir_sem_post(SEM_RX_DASIG);
      mix1_flag=1;
      goto narend;
      }
// new_baseb_flag == 1
// We want data in buffers corresponding to da_wait_time.
// We arrive here when there is more than that, move pointers
// to discard data corresponding to total_wttim-da_wait_time
// If there is too much data in memory, move the baseb pointer
// to discard more data.
    if(t1*genparm[DA_OUTPUT_SPEED] > 4)
      {
      i=t1*baseband_sampling_speed;
      if(i > baseb_wts-1)
        {
        baseb_fx+=baseb_wts-1;
        baseb_wts=1;
        lir_sem_post(SEM_RX_DASIG);
        mix1_flag=1;
        goto narend;
        }
      baseb_fx+=i-1;
      if(baseb_fx>baseband_size)baseb_fx-=baseband_size;
      baseb_wts-=i-1;
      }
    if(daout_px != daout_pa)
      {
      lir_sem_post(SEM_RX_DASIG);
      goto narend;
      }
    i=make_da_wts();
    if(kill_all_flag) goto wcw_error_exit;
    if(rx_da_totbytes-i == 0)
      {
      lir_sem_post(SEM_RX_DASIG);
      goto narend;
      }
    new_baseb_flag=0;
    sc[SC_BG_WATERF_REDRAW]+=3;
    if(cg.meter_graph_on != 0)sc[SC_MG_REDRAW]++;
    baseb_output_block=0.1*da_wait_time*baseband_sampling_speed*baseb_channels;
    t3=rx_daout_block/(4*rx_daout_channels*rx_daout_bytes*da_resample_ratio);
    if(baseb_output_block > t3)baseb_output_block=t3;
    if(baseb_output_block < 2)baseb_output_block=2;
    workload_reset_flag++;
    if( (ui.network_flag & NET_RX_INPUT) != 0)
      {
      net_send_slaves_freq();
      }
    goto start_output;
    }
narend:;
  }
// The narrowband thread uses data areas that belong to the
// baseband. The mouse (or keyboard) threads may call the
// routines in baseb_graph.c that reallocates memory for fft3 etc.
// The below is to avoid using unallocated memory.
if(thread_command_flag[THREAD_NARROWBAND_DSP] == THRFLAG_IDLE)
  {
  thread_status_flag[THREAD_NARROWBAND_DSP] = THRFLAG_IDLE;
  lir_sched_yield();
  while(thread_command_flag[THREAD_NARROWBAND_DSP] == THRFLAG_IDLE)
    {
    lir_sleep(5000);
    }
  if(thread_command_flag[THREAD_NARROWBAND_DSP] == THRFLAG_ACTIVE)
    {
    clear_da();
    if(kill_all_flag) goto wcw_error_exit;
    goto resume;
    }
  }
wcw_error_exit:;
thread_status_flag[THREAD_NARROWBAND_DSP]=THRFLAG_RETURNED;
while(thread_command_flag[THREAD_NARROWBAND_DSP] != THRFLAG_NOT_ACTIVE)
  {
  lir_sleep(1000);
  }
}

